package adapter;

import io.RuleCollectionWriter;

import java.io.File;
import java.util.ArrayList;

import fuzzy.FuzzyConclusion;
import fuzzy.FuzzyRule;
import fuzzy.FuzzySet;
import fuzzy.FuzzySetGauss;
import guiCore.FISVis;

public class FlexFisAdapter implements FRVAdapter{
	
	private FISVis sessionControler;
	
	//###############################################################################################
	// Constructor
	//###############################################################################################
	
	public FlexFisAdapter()
	{
		sessionControler = new FISVis();
	}
	
	//###############################################################################################
	// public Method
	//###############################################################################################
	
	public boolean start(double[][] mean_A
						, double[][] width_A
						, double[][] out_A
						, int[] rule_to_ID
						, int[][] ancestors
						, int max_ID
						, double[][] attr_range
						, double[] out_range
						, double[][] data
						, int numDataAll)
	{	
		String url = "C:\\Users\\client\\Desktop\\FVdataStore";
		
		for(int r=0; r < mean_A.length; r++)
		{
			//matlab to java indexing
			if(ancestors[r][0] > -1)
			ancestors[r][0] = ancestors[r][0] - 1;
			if(ancestors[r][1] > -1)
			ancestors[r][1] = ancestors[r][1] - 1;
			
			rule_to_ID[r] = rule_to_ID[r]-1;
			
		}
		
		//inform sessionControler
		sessionControler.startSession(mean_A,width_A,out_A,rule_to_ID,ancestors,max_ID-1,attr_range,out_range,data,numDataAll,url);
		
		return true;
	}
	
	public void update(double[][] mean_A
			, double[][] width_A
			, double[][] out_A
			, int[] rule_to_ID
			, int[][] ancestors
			, int max_ID
			, double[][] attr_range
			, double[] out_range
			, double[][] data
			, int numDataAll)
	{		
	
		
		for(int r=0; r < mean_A.length; r++)
		{
			//create FuzzySets antecedent

			
			//matlab to java indexing
			if(ancestors[r][0] > -1)
			ancestors[r][0] = ancestors[r][0] - 1;
			if(ancestors[r][1] > -1)
			ancestors[r][1] = ancestors[r][1] - 1;
			
			rule_to_ID[r] = rule_to_ID[r] - 1;
		}
		
		//inform sessionControler
		sessionControler.updateSession(mean_A
				, width_A
				, out_A
				, rule_to_ID
				, ancestors
				, max_ID - 1
				, attr_range
				, out_range
				, data
				, numDataAll);
	}

}
