package draw;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;

public class AndrewsView_AddStaticRuleDialog extends JDialog implements ActionListener{
	
	private JPanel panel_1;
	private JPanel panel_2;
	
	private JPanel panel_Center;
	private JPanel panel_South;
	
	private JRadioButton radio_0;
	private JRadioButton radio_1;
	private ButtonGroup buttonGroup;
	
	private JSpinner spinner_1;
	private JSpinner spinner_2;
	
	private JButton okButton;
	private JButton cancelButton;
	
	private AndrewsView av;
	private int index;
	
	//###############################################################################################
	// Constructor
	//###############################################################################################
	
	public AndrewsView_AddStaticRuleDialog(int curr_t, AndrewsView av_P, int index_P)
	{
		this.av = av_P;
		this.index = index_P;
		
		radio_0 = new JRadioButton(" at rule t' = ");
		radio_1 = new JRadioButton(" at rule t' = t - ");
		
		buttonGroup = new ButtonGroup();
		buttonGroup.add(radio_0);
		buttonGroup.add(radio_1);
		
		int min = av.getRuleInfoAt(av.getPAVruleAt(index).getId()).getBirth();
		int max = av.getRuleInfoAt(av.getPAVruleAt(index).getId()).getDeath() - 1;
		
		if(max < 0) max = curr_t;
		
		spinner_1 = new JSpinner(new SpinnerNumberModel(min			
				, min
				, max
				, 1));
		spinner_2 = new JSpinner(new SpinnerNumberModel(0, 0 ,max - min, 1));
		
		panel_1 = new JPanel();
		panel_1.setLayout(new FlowLayout(FlowLayout.LEFT));
		panel_1.add(radio_0);
		panel_1.add(spinner_1);
		
		panel_2 = new JPanel();
		panel_2.setLayout(new FlowLayout(FlowLayout.LEFT));
		panel_2.add(radio_1);
		panel_2.add(spinner_2);
		
		panel_Center = new JPanel();
		panel_Center.setLayout(new GridLayout(2,1));
		panel_Center.add(panel_1);
		panel_Center.add(panel_2);
		
		okButton = new JButton("ok");
		okButton.setActionCommand("ok");
		okButton.addActionListener(this);
		
		cancelButton = new JButton("cancel");
		cancelButton.setActionCommand("cancel");
		cancelButton.addActionListener(this);
		
		panel_South = new JPanel();
		panel_South.setLayout(new FlowLayout(FlowLayout.RIGHT));
		panel_South.add(okButton);
		panel_South.add(cancelButton);
		
		Container cp = this.getContentPane();
		cp.setLayout(new BorderLayout());
		
		cp.add(panel_Center, BorderLayout.CENTER);
		cp.add(panel_South, BorderLayout.SOUTH);
		
		this.setSize(200, 150);
		this.setLocation((int)(this.getToolkit().getScreenSize().getWidth()/2 - this.getWidth()/2),
							(int)(this.getToolkit().getScreenSize().getHeight()/2 - this.getHeight()/2));
		this.setModal(true);
		this.setVisible(true);
		
	}
	
	//###############################################################################################
	// Override Methods ActionListener
	//###############################################################################################

	@Override
	public void actionPerformed(ActionEvent arg0) 
	{
		if(arg0.getActionCommand().equals("cancel"))
		{
			this.dispose();
		}
		else if(arg0.getActionCommand().equals("ok"))
		{
			if(radio_0.isSelected())
			{
				av.addStaticRule(index, (Integer)spinner_1.getValue());
				
				this.dispose();
			}
			else if(radio_1.isSelected())
			{
				av.addDelayRule(index, (Integer)spinner_2.getValue());
				
				this.dispose();
			}
		}	
	} 

}
