package draw;

import guiUtil.InteractionField;

import java.awt.Graphics2D;
import java.awt.event.MouseEvent;

public class AttributeHistory_DeletInteraction extends InteractionField
{
	private int index;
	private AttributeHistoryView ahv;
	
	//###############################################################################################
	// Constructor
	//###############################################################################################
	
	public AttributeHistory_DeletInteraction(int index_P, AttributeHistoryView ahv_P)
	{
		this.index 	= index_P;
		this.ahv 	= ahv_P;
	}
	
	//###############################################################################################
	// Override Methods InteractionField
	//###############################################################################################
	
	@Override
	public void action(MouseEvent me, int eventType) 
	{
		if(eventType == MouseEvent.MOUSE_PRESSED)
		{
			ahv.removeRule(index);
		}				
	}

	@Override
	public void paintArea(Graphics2D g2d, DrawPanel dp, int size) 
	{
		g2d.drawImage(dp.getToolkit().getImage("res/icons/delete.png")
				, - size/2
				, - size/2
				, size
				, size
				, dp);
		
		g2d.drawRect( - size/2
				, - size/2
				, size
				, size);
	}
}