package draw;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;

public class AttributeHistory_PopUp extends JPopupMenu implements ActionListener{

	AttributeHistoryView ahv;
	
	JMenuItem clearItem;
	JMenuItem toLatex_Item;
	
	//###############################################################################################
	// Constructor
	//###############################################################################################
	
	public AttributeHistory_PopUp(AttributeHistoryView ahv_P)
	{
		ahv = ahv_P;
		
		clearItem = new JMenuItem("Clear");
		clearItem.setActionCommand("clear");
		clearItem.addActionListener(this);
		
		toLatex_Item = new JMenuItem("to Latex");
		toLatex_Item.setActionCommand("toLatex");
		toLatex_Item.addActionListener(this);
		
		this.add(clearItem);
		this.add(toLatex_Item);
	}
	
	//###############################################################################################
	// Override Methods ActionListener
	//###############################################################################################
	
	@Override
	public void actionPerformed(ActionEvent arg0) 
	{
		if(arg0.getActionCommand().equals(clearItem.getActionCommand()))
		{
			ahv.clear();
		}
		else if(arg0.getActionCommand().equals(toLatex_Item.getActionCommand()))
		{
			JFileChooser jfc = new JFileChooser();
			
			int save = jfc.showSaveDialog(this);
			
			if(save == 0)
			{
				File file = jfc.getSelectedFile();
				
				try 
				{
					File iFile = new File(file.toString() + ".tex");
							FileWriter fw = new FileWriter(iFile);
							BufferedWriter bw = new BufferedWriter(fw);
							bw.write(ahv.printToLatex());
							bw.close();
							fw.close();
							
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}		
	}
}

