package draw;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.util.ArrayList;

import javax.swing.JPanel;

public class DrawPanel extends JPanel{
	
	ArrayList<DrawObject> drawO_List = new ArrayList<DrawObject>();
	
	//###############################################################################################
	// Constructor
	//###############################################################################################
	
	//###############################################################################################
	// Methods
	//###############################################################################################
		
	public void paintComponent(Graphics g){
		super.paintComponent(g);
		
		//upcast
		Graphics2D g2D = (Graphics2D)g;
		
		g2D.setRenderingHint(RenderingHints.KEY_ANTIALIASING
				, RenderingHints.VALUE_ANTIALIAS_ON );
		
		for(DrawObject drawO: drawO_List)
		{
			drawO.draw(g2D);
		}		
	}
	
	public void addDrawObject(DrawObject drawObject)
	{
		drawO_List.add(drawObject);
	}
	
	public void removeDrawObject(int index)
	{
		drawO_List.remove(index);
	}
	
	public void clear()
	{
		drawO_List.clear();
	}
	
	//###############################################################################################
	// GET and SET
	//###############################################################################################
}
