package draw;

import java.awt.Graphics2D;
import java.util.ArrayList;

public class EntropyPlot extends DrawObject{
	
	private ArrayList<Double> entropy_List = new ArrayList<Double>();
	
	private int dis_H = 10;
	private double y_scaleFactor = 100;
	
	//###############################################################################################
	// Override Method DrawObject
	//###############################################################################################

	@Override
	public void draw(Graphics2D g2d) 
	{
		for(int i=1; i<entropy_List.size(); i++)
		{
			g2d.drawLine(dis_H * (i-1)
					, (int)(entropy_List.get(i-1) * y_scaleFactor)
					, dis_H * i
					, (int)(entropy_List.get(i) * y_scaleFactor));
		}		
	}

	//###############################################################################################
	// GET and SET
	//###############################################################################################

	public ArrayList<Double> getEntropy_List() {
		return entropy_List;
	}

	public void setEntropy_List(ArrayList<Double> entropy_List) {
		this.entropy_List = entropy_List;
	}
	
}
