package draw;

import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;

public class FamilyTree_PopUp extends JPopupMenu implements ActionListener{

	FamilyTreeView ftv;
	
	JMenu zoomMenu;
	
	JButton zoomIn;
	JButton zoomOut;
	
	JMenuItem toLatex_Item;
	
	JPanel zoomPanel;
	
	//###############################################################################################
	// Constructor
	//###############################################################################################
	
	public FamilyTree_PopUp(FamilyTreeView ftv_P)
	{
		ftv = ftv_P;
		
		zoomIn = new JButton("in");
		zoomIn.setActionCommand("zoomIn");
		zoomIn.addActionListener(this);
		zoomOut = new JButton("out");
		zoomOut.setActionCommand("zoomOut");
		zoomOut.addActionListener(this);
		
		zoomPanel = new JPanel();
		zoomPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		zoomPanel.add(zoomIn);
		zoomPanel.add(zoomOut);
		
		zoomMenu = new JMenu("Zoom");
		zoomMenu.add(zoomPanel);
		
		toLatex_Item = new JMenuItem("to Latex");
		toLatex_Item.setActionCommand("toLatex");
		toLatex_Item.addActionListener(this);
		
		this.add(zoomMenu);
		this.add(toLatex_Item);
	}
	
	//###############################################################################################
	// Override Methods ActionListener
	//###############################################################################################
	
	@Override
	public void actionPerformed(ActionEvent arg0) 
	{
		if(arg0.getActionCommand().equals(zoomIn.getActionCommand()))
		{
			ftv.zoomIN();
		}
		else if(arg0.getActionCommand().equals(zoomOut.getActionCommand()))
		{
			ftv.zoomOut();
		}
		else if(arg0.getActionCommand().equals(toLatex_Item.getActionCommand()))
		{
			JFileChooser jfc = new JFileChooser();
			
			int save = jfc.showSaveDialog(this);
			
			if(save == 0)
			{
				File file = jfc.getSelectedFile();
				
				try 
				{
					File iFile = new File(file.toString() + ".tex");
							FileWriter fw = new FileWriter(iFile);
							BufferedWriter bw = new BufferedWriter(fw);
							bw.write(ftv.toLatex());
							bw.close();
							fw.close();
							
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
		
	}

}
