package draw;

import guiCore.Session;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.util.ArrayList;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class FisDifMap_SliderPanel extends JPanel{
	
	private FisDifMapView fdmv;
	private Session session;
	
	private JSlider[] slider_A;
	
	//###############################################################################################
	// Constructor
	//###############################################################################################
	
	public FisDifMap_SliderPanel(FisDifMapView fdmv_P, Session session_P)
	{
		fdmv = fdmv_P;
		session = session_P;
		
		slider_A = new JSlider[session.getFr_premiseSize()];
		buildSlider();
	}
	
	//###############################################################################################
	// private Methods
	//###############################################################################################
	
	public void buildSlider()
	{
		
		int numSelecAttr = 2;
		
		if(fdmv.getSelectedAttr_1() == fdmv.getSelectedAttr_2()) numSelecAttr = 1;
				
		JPanel sliderPanel = new JPanel();
		sliderPanel.setLayout(new GridLayout(1,session.getFr_premiseSize()-numSelecAttr));
		
		for(int i=0; i<session.getFr_premiseSize(); i++)
		{
			if(i != fdmv.getSelectedAttr_1() && i != fdmv.getSelectedAttr_2())
			{
				int normValue = (int)((fdmv.getProtoDatapoint()[i] - session.getAttr_RangeAt(i)[0])
									/(session.getAttr_RangeAt(i)[1] - session.getAttr_RangeAt(i)[0])*1000);
				
				slider_A[i] = new JSlider(JSlider.VERTICAL
						,0
						,1000
						,normValue);
				
				slider_A[i].setName(""+i+"X");
				slider_A[i].addChangeListener(new ChangeListener(){

					@Override
					public void stateChanged(ChangeEvent arg0) {
						
						JSlider source = (JSlider)arg0.getSource();
						
						String[] nameAndCount = source.getName().split("X");
						
						int index = Integer.parseInt(nameAndCount[0]);

						double toSetValue = source.getValue()/1000d 
								           * (session.getAttr_RangeAt(index)[1] - session.getAttr_RangeAt(index)[0])
								           + session.getAttr_RangeAt(index)[0];		
						
						fdmv.getProtoDatapoint()[index] = toSetValue;
							
						fdmv.repaintDrawPanel();
					}				
				});
				
				JPanel helpPanel = new JPanel();
				helpPanel.setLayout(new BorderLayout());
				helpPanel.setBorder(new TitledBorder(""+i));
				helpPanel.setPreferredSize(new Dimension(40,400));
				helpPanel.add(slider_A[i], BorderLayout.CENTER);
				
				sliderPanel.add(helpPanel);
			}
			else
			{
				slider_A[i] = null;
			}
		}
		
		this.removeAll();
		this.setLayout(new BorderLayout());
		this.add(new JScrollPane(sliderPanel), BorderLayout.CENTER);
		this.revalidate();
	}

}
