package draw;

import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JLabel;
import javax.swing.JSpinner;
import javax.swing.JToolBar;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class FisDifMap_ToolBar extends JToolBar implements ChangeListener{
	
	private JLabel 		genLabel_1;
	private JLabel		genLabel_2;
	private JSpinner 	genSpinner_1;
	private JSpinner 	genSpinner_2;
	
	private JLabel 		attrLabel_1;
	private JLabel		attrLabel_2;
	private JSpinner 	attrSpinner_1;
	private JSpinner 	attrSpinner_2;
	
	private FisDifMapView fdmv;
	
	//###############################################################################################
	// Constructor
	//###############################################################################################
	
	public FisDifMap_ToolBar(FisDifMapView fdmv_P)
	{
		fdmv = fdmv_P;
		
		genLabel_1 = new JLabel("FIS 1");
		genLabel_2 = new JLabel("FIS_2");
		
		genSpinner_1 = new JSpinner(new SpinnerNumberModel(0,0,0,1));
		genSpinner_1.setName("gen1");
		genSpinner_1.addChangeListener(this);
		genSpinner_2 = new JSpinner(new SpinnerNumberModel(0,0,0,1));
		genSpinner_2.setName("gen2");
		genSpinner_2.addChangeListener(this);
		
		attrLabel_1 = new JLabel("Attr. 1");
		attrLabel_2 = new JLabel("Attr. 2");
		
		attrSpinner_1 = new JSpinner(new SpinnerNumberModel(0, 0, fdmv.getSession().getFr_premiseSize(), 1));
		attrSpinner_1.setName("attr1");
		attrSpinner_1.addChangeListener(this);
		attrSpinner_2 = new JSpinner(new SpinnerNumberModel(0, 0, fdmv.getSession().getFr_premiseSize(), 1));
		attrSpinner_2.setName("attr2");
		attrSpinner_2.addChangeListener(this);
		
		this.setLayout(new FlowLayout(FlowLayout.LEFT));
		
		this.add(genLabel_1);
		this.add(genSpinner_1);
		this.add(genLabel_2);
		this.add(genSpinner_2);
		this.addSeparator();
		this.add(attrLabel_1);
		this.add(attrSpinner_1);
		this.add(attrLabel_2);
		this.add(attrSpinner_2);
	}
	
	//###############################################################################################
	// Override Methods ChangeListener
	//###############################################################################################

	@Override
	public void stateChanged(ChangeEvent arg0) 
	{
		JSpinner spinner = (JSpinner)arg0.getSource();
	
		if(spinner.getName().equals("gen1"))
		{
			fdmv.setSelectedFIS_1((Integer)spinner.getValue());
		}
		else if(spinner.getName().equals("gen2"))
		{
			fdmv.setSelectedFIS_2((Integer)spinner.getValue());
		}
		else if(spinner.getName().equals("attr1"))
		{
			fdmv.setSelectedAttr_1((Integer)spinner.getValue());
			fdmv.buildSilder();
		}
		else if(spinner.getName().equals("attr2"))
		{
			fdmv.setSelectedAttr_2((Integer)spinner.getValue());
			fdmv.buildSilder();
		}
				
		fdmv.repaintDrawPanel();
	}
	
	//###############################################################################################
	// private Methods
	//###############################################################################################
	
	public void setSpinnerMaxValue(int value)
	{
		((SpinnerNumberModel)genSpinner_1.getModel()).setMaximum(value);
		((SpinnerNumberModel)genSpinner_2.getModel()).setMaximum(value);
	}


}
