package draw;

import guiCore.Session;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.MouseEvent;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;

import listener.CleverMouseListener;
import listener.MouseInteractionObject;

public class GlobalMonitor extends JPanel implements MouseInteractionObject{
	
	private Session session;
	
//	GlobalPlot entropyPlot;
	
	GlobalPlot entropyPlot2;
	
	GlobalPlot membershipPlot;
//	GlobalPlot fisfisWLMDPlot;
	GlobalPlot fisfisWLEFPlot;
	GlobalPlot fisfisPMHPlot;
	GlobalPlot fisfisWLASPlot;
	GlobalPlot numRules;
	GlobalPlot bornDeathIndexPlot;
	
	private JPanel mainPanel;
	private DrawPanel drawPanel = new DrawPanel();
	
	// infoPanel ----------------------
	
	private JLabel gen_Label;
	private JLabel currGen_Label;
	private JLabel lastGen_Label;
	private JLabel lastShownGen_Label;
	private JLabel gen_Label_1;
	private JLabel gen_Label_2;
	private JLabel gen_Label_3;
	private JLabel readData_Label;
	private JLabel readData_Label_1;
	private JLabel readData_Label_2;
	private JLabel readData_Label_3;
	private JLabel readDataAll_Label;
	private JLabel readDataAll_Label_1;
	private JLabel readDataAll_Label_2;
	private JLabel readDataAll_Label_3;

	
	
	private JPanel infoPanel;
	// --------------------------------
	
	private CleverMouseListener cml = new CleverMouseListener();
	
	//###############################################################################################
	// Constructor
	//###############################################################################################
	
	public GlobalMonitor(Session session_P)
	{
		cml.addToPressedList(this);
		cml.addToReleasedList(this);
		
		drawPanel.addMouseListener(cml);
		drawPanel.addMouseMotionListener(cml);
		
		session = session_P;
			
//		entropyPlot = new GlobalPlot("Entropy",1);
//		entropyPlot.getaTrans().translate(60, 30);
		
		entropyPlot2 = new GlobalPlot("Entropy2",1);
		entropyPlot2.getaTrans().translate(60, 30);
		
		membershipPlot = new GlobalPlot("Membership",1);
		membershipPlot.getaTrans().translate(0, 150);
//		fisfisWLMDPlot = new GlobalPlot("FIS vs. FIS WL-MD");
//		fisfisWLMDPlot.getaTrans().translate(0, 150);
		fisfisWLEFPlot = new GlobalPlot("FIS vs. FIS WL-EF",1);
		fisfisWLEFPlot.getaTrans().translate(0, 150);
		fisfisPMHPlot = new GlobalPlot("FIS vs. FIS PM-H",1);
		fisfisPMHPlot.getaTrans().translate(0, 150);
		fisfisWLASPlot = new GlobalPlot("FIS vs. FIS WL-AS",1);
		fisfisWLASPlot.getaTrans().translate(0, 150);
		numRules = new GlobalPlot("Number of Rules",3);
		numRules.addColor(Color.green);
		numRules.addColor(Color.red);
		numRules.getaTrans().translate(0, 150);
		bornDeathIndexPlot = new GlobalPlot("Born-Death-Index",2);
		bornDeathIndexPlot.setColor(Color.green, 0);
		bornDeathIndexPlot.addColor(Color.red);
		bornDeathIndexPlot.getaTrans().translate(0, 150);

//		drawPanel.addDrawObject(entropyPlot);
		
		drawPanel.addDrawObject(entropyPlot2);
		
		drawPanel.addDrawObject(membershipPlot);
//		drawPanel.addDrawObject(fisfisWLMDPlot);
		drawPanel.addDrawObject(fisfisWLEFPlot);		
		drawPanel.addDrawObject(fisfisPMHPlot);
		drawPanel.addDrawObject(fisfisWLASPlot);
		drawPanel.addDrawObject(numRules);
		drawPanel.addDrawObject(bornDeathIndexPlot);
		
		// infoPanel -----------------------------------
		
		gen_Label = new JLabel("Generation : ");
		currGen_Label = new JLabel("current");
		lastGen_Label = new JLabel("last");
		lastShownGen_Label = new JLabel("last displayed");
		gen_Label_1 = new JLabel("0");
		gen_Label_2 = new JLabel("0");
		gen_Label_3 = new JLabel("0");
		readData_Label = new JLabel("Data Count : ");
		readData_Label_1 = new JLabel("0");
		readData_Label_2 = new JLabel("0");
		readData_Label_3 = new JLabel("0");
		readDataAll_Label = new JLabel("DataAll Count : ");
		readDataAll_Label_1 = new JLabel("0");
		readDataAll_Label_2 = new JLabel("0");
		readDataAll_Label_3 = new JLabel("0");
		
		infoPanel = new JPanel();
		infoPanel.setLayout(new GridLayout(4,4));
		
		infoPanel.add(new JLabel(""));
		infoPanel.add(currGen_Label);
		infoPanel.add(lastGen_Label);
		infoPanel.add(lastShownGen_Label);
		infoPanel.add(gen_Label);
		infoPanel.add(gen_Label_1);
		infoPanel.add(gen_Label_2);
		infoPanel.add(gen_Label_3);
		infoPanel.add(readData_Label);
		infoPanel.add(readData_Label_1);
		infoPanel.add(readData_Label_2);
		infoPanel.add(readData_Label_3);
		infoPanel.add(readDataAll_Label);
		infoPanel.add(readDataAll_Label_1);
		infoPanel.add(readDataAll_Label_2);
		infoPanel.add(readDataAll_Label_3);
		
		//----------------------------------------------
		
		JSplitPane splitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
		splitPane.setTopComponent(new JScrollPane(drawPanel));
		splitPane.setBottomComponent(new JScrollPane(infoPanel));
		splitPane.setDividerLocation(360);
		
		mainPanel = new JPanel();
		mainPanel.setLayout(new BorderLayout());
		mainPanel.add(splitPane, BorderLayout.CENTER);
	}
	
	//###############################################################################################
	// public Methods
	//###############################################################################################
	
	public Component getComponent()
	{
		return mainPanel;
	}
	
	public void updateMonitor()
	{
		updateInfoPanel();
		
//		entropyPlot.setValue_List(session.getGlobalMemFunc().getEntropy_List(), session.getGlobalMemFunc().getMaxEvo(),0);
		
		entropyPlot2.setValue_List(session.getGlobalMemFunc().getEntropy2_List(), session.getGlobalMemFunc().getMaxEvo2(),0);
		
		membershipPlot.setValue_List(session.getGlobalMemFunc().getGlobalMem_List(), session.getGlobalMemFunc().getMaxMem(),0);
//		fisfisWLMDPlot.setValue_List(session.getGlobalMemFunc().getFis_fis_Dis_List(), session.getGlobalMemFunc().getMaxMD(),0);
		fisfisWLEFPlot.setValue_List(session.getGlobalMemFunc().getFis_fis_EFDis_List(), session.getGlobalMemFunc().getMaxEF(),0);
		fisfisPMHPlot.setValue_List(session.getGlobalMemFunc().getFis_fis_PMHDis_List(), session.getGlobalMemFunc().getMaxPMH(),0);
		fisfisWLASPlot.setValue_List(session.getGlobalMemFunc().getFis_fis_WLASSim_List(), session.getGlobalMemFunc().getMaxWLAS(),0);
		numRules.setValue_List(session.getGlobalMemFunc().getNumRules_List(), session.getGlobalMemFunc().getMaxNumR(),0);
		numRules.setValue_List(session.getGlobalMemFunc().getNumBorn_List(), session.getGlobalMemFunc().getMaxNumR(),1);
		numRules.setValue_List(session.getGlobalMemFunc().getNumDeath_List(), session.getGlobalMemFunc().getMaxNumR(),2);
		bornDeathIndexPlot.setValue_List(session.getGlobalMemFunc().getBornIndex_List(), 1,0);
		bornDeathIndexPlot.setValue_List(session.getGlobalMemFunc().getDeathIndex_List(), 1,1);
		drawPanel.setPreferredSize(new Dimension(session.getLastPopIndex() * GlobalPlot.dis_H + 200,7*150));
		drawPanel.repaint();
		drawPanel.revalidate();
	}
	
	public void saveMonitor()
	{
		JFileChooser jfc = new JFileChooser();
		
		int ok = jfc.showSaveDialog(this);
		
		if(ok == JFileChooser.APPROVE_OPTION)
		{
			File file = jfc.getSelectedFile();
			
			try 
			{
				BufferedWriter bfw = new BufferedWriter(new FileWriter(file));
				
				bfw.write("Entropy;");
				bfw.write("Membership;");
				bfw.write("ErrorFunc;");
				bfw.write("partition Measure;");
				bfw.write("Angle Sim;");
				bfw.newLine();
				
				for(int i=0; i<session.getGlobalMemFunc().getEntropy_List().size(); i++)
				{
					bfw.write(session.getGlobalMemFunc().getEntropy_List().get(i)+";");
					bfw.write(session.getGlobalMemFunc().getGlobalMem_List().get(i) + ";");
					bfw.write(session.getGlobalMemFunc().getFis_fis_EFDis_List().get(i) + ";");
					bfw.write(session.getGlobalMemFunc().getFis_fis_PMHDis_List().get(i) + ";");
					bfw.write(session.getGlobalMemFunc().getFis_fis_WLASSim_List().get(i) + "");
					bfw.newLine();
				}
				
				bfw.close();
				
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}		
	}
	
	public void monitorToLatex()
	{
		JFileChooser jfc = new JFileChooser();
		jfc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		
		
		int ok = jfc.showOpenDialog(this);
		
		if(ok == JFileChooser.APPROVE_OPTION)
		{
			File file = jfc.getSelectedFile();
			
			File fileEntropy = new File(file.toString()+"\\entropy.dat");
			File fileMembership = new File(file.toString()+"\\Membership.dat");
			File fileEFSim = new File(file.toString()+"\\EFSim.dat");
			File fileHPM = new File(file.toString()+"\\HPM.dat");
			File fileAngleSim = new File(file.toString()+"\\AngleSim.dat");
			File fileNumRules = new File(file.toString()+"\\NumRules.dat");
			File fileNumBornRules = new File(file.toString()+"\\NumBornRules.dat");
			File fileNumDeathRules = new File(file.toString()+"\\NumDeathRules.dat");
			
			try 
			{
				//Entropie
				BufferedWriter bfw = new BufferedWriter(new FileWriter(fileEntropy));
						
				bfw.write("[");
				for(int i=0; i<session.getGlobalMemFunc().getEntropy_List().size()-1; i++)
				{
					bfw.write("{"+i+","+session.getGlobalMemFunc().getEntropy_List().get(i)+"},");
				}
				bfw.write("{"+(session.getGlobalMemFunc().getEntropy_List().size()-1)+","+session.getGlobalMemFunc().getEntropy_List().get(session.getGlobalMemFunc().getEntropy_List().size()-1)+"}]");
				bfw.close();
				
				//Membership
				bfw = new BufferedWriter(new FileWriter(fileMembership));
						
				bfw.write("[");
				for(int i=0; i<session.getGlobalMemFunc().getGlobalMem_List().size()-1; i++)
				{
					bfw.write("{"+i+","+session.getGlobalMemFunc().getGlobalMem_List().get(i)+"},");
				}
				bfw.write("{"+(session.getGlobalMemFunc().getGlobalMem_List().size()-1)+","+session.getGlobalMemFunc().getGlobalMem_List().get(session.getGlobalMemFunc().getGlobalMem_List().size()-1)+"}]");
				bfw.close();
				
				//ErrorFunction Simularity
				bfw = new BufferedWriter(new FileWriter(fileEFSim));
						
				bfw.write("[");
				for(int i=0; i<session.getGlobalMemFunc().getFis_fis_EFDis_List().size()-1; i++)
				{
					bfw.write("{"+i+","+session.getGlobalMemFunc().getFis_fis_EFDis_List().get(i)+"},");
				}
				bfw.write("{"+(session.getGlobalMemFunc().getFis_fis_EFDis_List().size()-1)+","+session.getGlobalMemFunc().getFis_fis_EFDis_List().get(session.getGlobalMemFunc().getFis_fis_EFDis_List().size()-1)+"}]");
				bfw.close();
				
				//Huellermeier Partition Measure Simularity
				bfw = new BufferedWriter(new FileWriter(fileHPM));
						
				bfw.write("[");
				for(int i=0; i<session.getGlobalMemFunc().getFis_fis_PMHDis_List().size()-1; i++)
				{
					bfw.write("{"+i+","+session.getGlobalMemFunc().getFis_fis_PMHDis_List().get(i)+"},");
				}
				bfw.write("{"+(session.getGlobalMemFunc().getFis_fis_PMHDis_List().size()-1)+","+session.getGlobalMemFunc().getFis_fis_PMHDis_List().get(session.getGlobalMemFunc().getFis_fis_PMHDis_List().size()-1)+"}]");
				bfw.close();
				
				//Angle Simularity
				bfw = new BufferedWriter(new FileWriter(fileAngleSim));
						
				bfw.write("[");
				for(int i=0; i<session.getGlobalMemFunc().getFis_fis_WLASSim_List().size()-1; i++)
				{
					bfw.write("{"+i+","+session.getGlobalMemFunc().getFis_fis_WLASSim_List().get(i)+"},");
				}
				bfw.write("{"+(session.getGlobalMemFunc().getFis_fis_WLASSim_List().size()-1)+","+session.getGlobalMemFunc().getFis_fis_WLASSim_List().get(session.getGlobalMemFunc().getFis_fis_WLASSim_List().size()-1)+"}]");
				bfw.close();
				
				//Number Rules
				bfw = new BufferedWriter(new FileWriter(fileNumRules));
						
				bfw.write("[");
				for(int i=0; i<session.getGlobalMemFunc().getNumRules_List().size()-1; i++)
				{
					bfw.write("{"+i+","+session.getGlobalMemFunc().getNumRules_List().get(i)+"},");
				}
				bfw.write("{"+(session.getGlobalMemFunc().getNumRules_List().size()-1)+","+session.getGlobalMemFunc().getNumRules_List().get(session.getGlobalMemFunc().getNumRules_List().size()-1)+"}]");
				bfw.close();
				
				//Number Born Rules
				bfw = new BufferedWriter(new FileWriter(fileNumBornRules));
						
				bfw.write("[");
				for(int i=0; i<session.getGlobalMemFunc().getNumBorn_List().size()-1; i++)
				{
					bfw.write("{"+i+","+session.getGlobalMemFunc().getNumBorn_List().get(i)+"},");
				}
				bfw.write("{"+(session.getGlobalMemFunc().getNumBorn_List().size()-1)+","+session.getGlobalMemFunc().getNumBorn_List().get(session.getGlobalMemFunc().getNumBorn_List().size()-1)+"}]");
				bfw.close();
				
				//Number Death Rules
				bfw = new BufferedWriter(new FileWriter(fileNumDeathRules));
						
				bfw.write("[");
				for(int i=0; i<session.getGlobalMemFunc().getNumDeath_List().size()-1; i++)
				{
					bfw.write("{"+i+","+session.getGlobalMemFunc().getNumDeath_List().get(i)+"},");
				}
				bfw.write("{"+(session.getGlobalMemFunc().getNumDeath_List().size()-1)+","+session.getGlobalMemFunc().getNumDeath_List().get(session.getGlobalMemFunc().getNumDeath_List().size()-1)+"}]");
				bfw.close();
				
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}
	}
	
	//###############################################################################################
	// private Methods
	//###############################################################################################
	
	private void updateInfoPanel()
	{
		gen_Label_1.setText(session.getCurrPopulationIndex()+"");
		gen_Label_2.setText(session.getLastPopIndex()+"");
		gen_Label_3.setText(session.getNewestCollectionIndex()+"");

		if(session.getDataCountAt(session.getLastPopIndex()) > -1)
		{
			readData_Label_1.setText(session.getDataCountAt(session.getCurrPopulationIndex())+"");
			readData_Label_2.setText(session.getDataCountAt(session.getLastPopIndex())+"");
			readData_Label_3.setText(session.getDataCountAt(session.getNewestCollectionIndex())+"");
		}
		
		if(session.getDataAllCountAt(session.getLastPopIndex()) > -1)
		{
			readDataAll_Label_1.setText(session.getDataAllCountAt(session.getCurrPopulationIndex())+"");
			readDataAll_Label_2.setText(session.getDataAllCountAt(session.getLastPopIndex())+"");
			readDataAll_Label_3.setText(session.getDataAllCountAt(session.getNewestCollectionIndex())+"");
		}

	}
	
	//###############################################################################################
	// Override Methods MouseInteractionObject
	//###############################################################################################
	
	@Override
	public boolean action(MouseEvent me, int eventType) {
		

		switch(eventType){
		
		//############ CLICKED #################################################################
			case CleverMouseListener.CLICKED: 	break;
		//############ ENTERED #################################################################
			case CleverMouseListener.ENTERED:	break;
		//############ EXITED  #################################################################
			case CleverMouseListener.EXITED:	break;		
		//############ PRESSED #################################################################
			case CleverMouseListener.PRESSED: 
				
				GlobalMonitor_Popup gm_Popup = new GlobalMonitor_Popup(this);
												
				if(me.isPopupTrigger())
				{	

					gm_Popup.show(me.getComponent(), me.getX(), me.getY());
				}

				break;
		//############ RELEASED #################################################################		
			case CleverMouseListener.RELEASED:
				
				gm_Popup = new GlobalMonitor_Popup(this);
				
				if(me.isPopupTrigger())
				{	

					gm_Popup.show(me.getComponent(), me.getX(), me.getY());
				}
				break;
		//############ DRAGGED #################################################################		
			case CleverMouseListener.DRAGGED: break;
		//############ MOVED   #################################################################
			case CleverMouseListener.MOVED: 	break;
		}
		
		drawPanel.repaint();
		
		return false;
	}

	@Override
	public boolean hitObject(MouseEvent me) 
	{
		return true;
	}


}
