package draw;

import guiUtil.RolloverButton;
import guiUtil.RolloverToggleButton;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JPopupMenu;
import javax.swing.JToolBar;

public class LocalWalkView_ToolBar extends JToolBar implements ActionListener{
	
	private LocalWalkView lwv;
	
	private RolloverButton zoomIn;
	private RolloverButton zoomOut;
	
	private RolloverToggleButton showWidth_Button;
	
	private RolloverButton selectAttrButton;
	private int numSelectedAttr;
	
	//###############################################################################################
	// Constructor
	//###############################################################################################
	
	public LocalWalkView_ToolBar(LocalWalkView lwv_P)
	{
		this.lwv = lwv_P;
		
		this.numSelectedAttr = lwv.getSession().getFr_premiseSize();
		
		zoomIn = new RolloverButton(new ImageIcon("res/icons/collapsed.gif"));		
		zoomIn.setPreferredSize(new Dimension(20,20));
		zoomIn.setActionCommand("zIN");
		zoomIn.addActionListener(this);
		
		zoomOut = new RolloverButton(new ImageIcon("res/icons/expanded.gif"));
		zoomOut.setPreferredSize(new Dimension(20,20));
		zoomOut.setActionCommand("zOUT");
		zoomOut.addActionListener(this);
		
		selectAttrButton = new RolloverButton("sA");
		selectAttrButton.setPreferredSize(new Dimension(20,20));
		selectAttrButton.setActionCommand("sA");
		selectAttrButton.addActionListener(this);
		
		showWidth_Button = new RolloverToggleButton("showWidth");
		showWidth_Button.setActionCommand("showWidth");
		showWidth_Button.addActionListener(this);
		showWidth_Button.setSelected(true);
		
		this.setLayout(new FlowLayout(FlowLayout.LEFT));
		
		this.add(zoomIn);
		this.add(zoomOut);
		this.add(selectAttrButton);
		this.add(showWidth_Button);
	}
	
	//###############################################################################################
	// Override Methods ActionListener
	//###############################################################################################

	@Override
	public void actionPerformed(ActionEvent arg0) {
		
		if(arg0.getActionCommand().equals("zIN"))
		{
		
			lwv.zoomIN();
			lwv.repaintDrawPanel();
		}
		else if(arg0.getActionCommand().equals("zOUT"))
		{
			lwv.zoomOut();
			lwv.repaintDrawPanel();
		}
		else if(arg0.getActionCommand().equals("sA"))
		{
			JPopupMenu popupM = new JPopupMenu();
			
			for(int i=0; i < lwv.getSession().getFr_premiseSize(); i++)
			{
				JCheckBox checkBox = new JCheckBox("Attribute "+i);
				checkBox.setActionCommand("check");
				checkBox.addActionListener(this);
				popupM.add(checkBox);
				
				checkBox.setSelected(lwv.getEnabledAttr_A()[i]);
				
			}
			
			popupM.show(lwv.getComponent()
					,selectAttrButton.getX()
					,selectAttrButton.getY()+25);
		}
		else if(arg0.getActionCommand().equals("check"))
		{
			JCheckBox checkBox = (JCheckBox)arg0.getSource();
			
			if(checkBox.isSelected())
			{
				this.numSelectedAttr++;
			}
			else if(this.numSelectedAttr == 2)
			{
				checkBox.setSelected(true);
			}
			else
			{
				this.numSelectedAttr--;
			}
			
			JPopupMenu popupM = (JPopupMenu)(checkBox).getParent();
			
			
			for(int i=0; i< lwv.getSession().getFr_premiseSize(); i++)
			{
				lwv.getEnabledAttr_A()[i] = ((JCheckBox)popupM.getComponent(i)).isSelected();				
			}
			
			lwv.getSession().repaintRV();			
		}
		else if(arg0.getActionCommand().equals(showWidth_Button.getActionCommand()))
		{
			lwv.setShowWidth(showWidth_Button.isSelected());
			lwv.repaintDrawPanel();
		}
	}
}
