package draw;

import java.awt.Color;
import java.awt.Graphics2D;

import fuzzy.FuzzyRule;

public class MatrixViewRule extends DrawObject{
	
	private FuzzyRule fr;
	private MatrixView mv;
	
	//###############################################################################################
	// Constructor
	//###############################################################################################
	
	public MatrixViewRule(FuzzyRule fr, MatrixView mv)
	{
		this.fr = fr;
		this.mv = mv;
	}
	
	//###############################################################################################
	// Override Methods DrawObject
	//###############################################################################################

	@Override
	public void draw(Graphics2D g2D) {
		
		g2D.setColor(new Color(200,0,0));
		g2D.fillRoundRect(mv.getPadding()
				, mv.getPadding()
				, mv.getRule_width()
				, mv.getRule_height()
				, 10
				, 10);	
	}
	
	//###############################################################################################
	// GET and SET
	//###############################################################################################

	public FuzzyRule getFr() {
		return fr;
	}

}
