package draw;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JRadioButton;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class MatrixView_PopUp extends JPopupMenu implements ActionListener, ChangeListener{
	
	private MatrixView mv;
	
	private JMenu distanceTypeMenu;
	
	private JRadioButton radio_1;
	private JRadioButton radio_2;
//	private JRadioButton radio_3;
//	private JRadioButton radio_4;
	private JRadioButton radio_5;
	private JRadioButton radio_6;
	
	private JCheckBox check_1;
	
	private JPanel panel_1;
	private JPanel panel_2;
//	private JPanel panel_3;
//	private JPanel panel_4;
	private JPanel panel_5;
	private JPanel panel_6;
	
	JMenu zoomMenu;
	
	JButton zoomIn;
	JButton zoomOut;
	
	private JMenuItem saveAsImageItem;
	
	JPanel zoomPanel;
	
//	private JSpinner spinner_3;
//	private JSpinner spinner_4;
	private ButtonGroup bGroup;
	
	//###############################################################################################
	// Constructor
	//###############################################################################################

	public MatrixView_PopUp(MatrixView mv_P)
	{
		mv = mv_P;
		
		radio_1 = new JRadioButton("Euclide");
		radio_1.setActionCommand("radio1");
		radio_1.addActionListener(this);
		radio_2 = new JRadioButton("Antecedense Similarity");
		radio_2.setActionCommand("radio2");
		radio_2.addActionListener(this);
//		radio_3 = new JRadioButton("HL");
//		radio_3.setActionCommand("radio3");
//		radio_3.addActionListener(this);
//		radio_4 = new JRadioButton("HL-O");
//		radio_4.setActionCommand("radio4");
//		radio_4.addActionListener(this);
		radio_5 = new JRadioButton("Angle");
		radio_5.setActionCommand("radio5");
		radio_5.addActionListener(this);
		
		radio_6 = new JRadioButton("Gray");
		radio_6.setActionCommand("radio6");
		radio_6.addActionListener(this);
		
		saveAsImageItem = new JMenuItem("save as image");
		saveAsImageItem.setActionCommand("saveAsImage");
		saveAsImageItem.addActionListener(this);
		
//		spinner_3 = new JSpinner(new SpinnerNumberModel(mv.getNumHLSamples(), 0, 10000, 1));
//		spinner_3.setName("spinner3");
//		spinner_3.addChangeListener(this);
//		spinner_3.setPreferredSize(new Dimension(60,20));
//		spinner_4 = new JSpinner(new SpinnerNumberModel(mv.getNumHLSamples(), 0, 10000, 1));
//		spinner_4.setName("spinner4");
//		spinner_4.addChangeListener(this);
//		spinner_4.setPreferredSize(new Dimension(60,20));
		
		panel_1 = new JPanel();
		panel_1.setLayout(new FlowLayout(FlowLayout.LEFT));
		panel_1.add(radio_1);
		
		panel_2 = new JPanel();
		panel_2.setLayout(new FlowLayout(FlowLayout.LEFT));
		panel_2.add(radio_2);
		
//		panel_3 = new JPanel();
//		panel_3.setLayout(new FlowLayout(FlowLayout.LEFT));
//		panel_3.add(radio_3);
//		panel_3.add(spinner_3);
//		
//		panel_4 = new JPanel();
//		panel_4.setLayout(new FlowLayout(FlowLayout.LEFT));
//		panel_4.add(radio_4);
//		panel_4.add(spinner_4);
		
		panel_5 = new JPanel();
		panel_5.setLayout(new FlowLayout(FlowLayout.LEFT));
		panel_5.add(radio_5);
		
		panel_6 = new JPanel();
		panel_6.setLayout(new FlowLayout(FlowLayout.LEFT));
		panel_6.add(radio_6);
		
		
		bGroup = new ButtonGroup();
		bGroup.add(radio_1);
		bGroup.add(radio_2);
//		bGroup.add(radio_3);
//		bGroup.add(radio_4);
		bGroup.add(radio_5);
		bGroup.add(radio_6);
		radio_1.setSelected(true);
		
		distanceTypeMenu = new JMenu("Distance..");
		distanceTypeMenu.add(panel_1);
		distanceTypeMenu.add(panel_2);
//		distanceTypeMenu.add(panel_3);
//		distanceTypeMenu.add(panel_4);
		distanceTypeMenu.add(panel_5);
		distanceTypeMenu.add(panel_6);
		
		check_1 = new JCheckBox("show Angle");
		check_1.setActionCommand("check1");
		check_1.addActionListener(this);
		check_1.setSelected(mv.isShowAngle());
		
		zoomIn = new JButton("in");
		zoomIn.setActionCommand("zoomIn");
		zoomIn.addActionListener(this);
		zoomOut = new JButton("out");
		zoomOut.setActionCommand("zoomOut");
		zoomOut.addActionListener(this);
		
		zoomPanel = new JPanel();
		zoomPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		zoomPanel.add(zoomIn);
		zoomPanel.add(zoomOut);
		
		zoomMenu = new JMenu("Zoom");
		zoomMenu.add(zoomPanel);
		
		this.add(distanceTypeMenu);
		this.add(check_1);
		this.add(zoomMenu);
		this.add(saveAsImageItem);
	}
	
	//###############################################################################################
	// Override Method ActionListener
	//###############################################################################################
	
	@Override
	public void actionPerformed(ActionEvent arg0) 
	{
		if(arg0.getActionCommand().equals(radio_1.getActionCommand()))
		{
			mv.setDistanceType(0);
			mv.repaintDrawPanel();
		}
		else if(arg0.getActionCommand().equals(radio_2.getActionCommand()))
		{
			mv.setDistanceType(1);
			mv.repaintDrawPanel();
		}
//		else if(arg0.getActionCommand().equals(radio_3.getActionCommand()))
//		{
//			mv.setDistanceType(2);
//			mv.repaintDrawPanel();
//		}
//		else if(arg0.getActionCommand().equals(radio_4.getActionCommand()))
//		{
//			mv.setDistanceType(3);
//			mv.repaintDrawPanel();
//		}
		else if(arg0.getActionCommand().equals(radio_5.getActionCommand()))
		{
			mv.setDistanceType(4);
			mv.repaintDrawPanel();
		}
		else if(arg0.getActionCommand().equals(radio_6.getActionCommand()))
		{
			mv.setDistanceType(5);
			mv.repaintDrawPanel();
		}
		else if(arg0.getActionCommand().equals(check_1.getActionCommand()))
		{
			mv.setShowAngle(check_1.isSelected());
			mv.repaintDrawPanel();
		}
		else if(arg0.getActionCommand().equals(zoomIn.getActionCommand()))
		{
			mv.zoomIN();
		}
		else if(arg0.getActionCommand().equals(zoomOut.getActionCommand()))
		{
			mv.zoomOut();
		}
		else if(arg0.getActionCommand().equals(saveAsImageItem.getActionCommand()))
		{
			MatrixView_ToImageDialog tid = new MatrixView_ToImageDialog(mv);
		}
	}
	
	//###############################################################################################
	// Override Method ChangeListener
	//###############################################################################################

	@Override
	public void stateChanged(ChangeEvent arg0) 
	{
//		JSpinner spinner = (JSpinner)arg0.getSource();
//		
//		if(spinner.getName().equals(spinner_3.getName()))
//		{
//			mv.setNumHLSamples((Integer)spinner.getValue());
//		}
		
	} 

}
