package draw;

import guiUtil.InteractionField;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;

public class ParallelAxis_DeleteInteraction extends InteractionField
{
	private ParallelAxisView plv;
	private int index;
	private int mode;
	private int subIndex;
	
	//###############################################################################################
	// Constructor
	//###############################################################################################
	
	public ParallelAxis_DeleteInteraction(ParallelAxisView plv_P, int index_P, int mode_P, int subIndex_P)
	{
		this.plv = plv_P;
		this.index = index_P;
		this.mode = mode_P;
		this.subIndex = subIndex_P;
	}
	
	//###############################################################################################
	// Override Methods InteractionField
	//###############################################################################################
	
	@Override
	public void action(MouseEvent me, int eventType) 
	{
		if(eventType == MouseEvent.MOUSE_PRESSED)
		{
			switch(mode)
			{
			case 0: 
				plv.removeRule(index);
				break;
				
			case 1:
				plv.removeStaticRule(index, subIndex);
				break;
				
			case 2:
				plv.removeDelayRule(index, subIndex);
				break;
			}			
		}				
	}

	@Override
	public void paintArea(Graphics2D g2d, DrawPanel dp, int size) 
	{
		g2d.drawImage(dp.getToolkit().getImage("res/icons/delete.png")
				, - size/2
				, - size/2
				, size
				, size
				, dp);
		
		g2d.drawRect( - size/2
				, - size/2
				, size
				, size);
	}

}
