package draw;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Graphics2D;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.TreeSet;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.imageio.ImageIO;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JSpinner;
import javax.swing.JTextArea;
import javax.swing.SpinnerNumberModel;
import javax.swing.border.TitledBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

public class ParallelAxis_ToImageDialog extends JDialog implements ActionListener, DocumentListener{
	
	private ParallelAxisView pav;
	
	JPanel mainPanel;
	
	JPanel checkBoxPanel;
	
	JPanel antecedencePanel;
	JPanel ap_1;
	JPanel ap_2;
	
	JPanel conclusionPanel;
	JPanel ap_3;
	JPanel ap_4;
	
	JPanel checkBoxPanel_2;
	JPanel ap_5;
	JPanel ap_6;
	
	JPanel textAreaPanel;
	
	JPanel centerPanel;
	
	JPanel buttonPanel;
	
	private JCheckBox antecedenceBox;
	private JCheckBox axisMarkingABox;
	private JLabel spaceALabel;
	
	private JCheckBox conclusionBox;
	private JCheckBox axisMarkingCBox;
	private JLabel spaceCLabel;
	
	private JCheckBox asMatrixBox;
	private JSpinner maxSpinner;
	private JRadioButton rowRadio;
	private JRadioButton columnRadio;
	
	private ButtonGroup buttonGroup;
	
	private JCheckBox singleBox;
	
	private JTextArea genTextArea;
	
	private JButton okButton;
	private JButton cancelButton;
	
	//###############################################################################################
	// Constructor
	//###############################################################################################
	
	public ParallelAxis_ToImageDialog(ParallelAxisView pav)
	{
		this.pav = pav;
		
		antecedenceBox = new JCheckBox("Antecedence");
		antecedenceBox.setSelected(true);
		antecedenceBox.setActionCommand("antecedence");
		antecedenceBox.addActionListener(this);
		
		axisMarkingABox = new JCheckBox("add axis marking");
		
		spaceALabel = new JLabel("   ");
		
		ap_1 = new JPanel();
		ap_1.setLayout(new FlowLayout(FlowLayout.LEFT));
		ap_1.add(antecedenceBox);
		
		ap_2 = new JPanel();
		ap_2.setLayout(new FlowLayout(FlowLayout.LEFT));
		ap_2.add(spaceALabel);
		ap_2.add(axisMarkingABox);
		
		antecedencePanel = new JPanel();
		antecedencePanel.setLayout(new BorderLayout());
		antecedencePanel.add(ap_1, BorderLayout.CENTER);
		antecedencePanel.add(ap_2, BorderLayout.SOUTH);
		
		conclusionBox = new JCheckBox("Conclusion");
		conclusionBox.setSelected(true);
		conclusionBox.setActionCommand("conclusion");
		conclusionBox.addActionListener(this);
		
		axisMarkingCBox = new JCheckBox("add axis marking");
		
		spaceCLabel = new JLabel("   ");
		
		ap_3 = new JPanel();
		ap_3.setLayout(new FlowLayout(FlowLayout.LEFT));
		ap_3.add(conclusionBox);
		
		ap_4 = new JPanel();
		ap_4.setLayout(new FlowLayout(FlowLayout.LEFT));
		ap_4.add(spaceCLabel);
		ap_4.add(axisMarkingCBox);
		
		conclusionPanel = new JPanel();
		conclusionPanel.setLayout(new BorderLayout());
		conclusionPanel.add(ap_3, BorderLayout.CENTER);
		conclusionPanel.add(ap_4, BorderLayout.SOUTH);
		
		checkBoxPanel = new JPanel();
		checkBoxPanel.setLayout(new GridLayout(2,1));
		checkBoxPanel.add(antecedencePanel);
		checkBoxPanel.add(conclusionPanel);
		
		asMatrixBox = new JCheckBox("as matrix");
		
		rowRadio = new JRadioButton("row");
		rowRadio.setSelected(true);
		
		columnRadio = new JRadioButton("column");
		
		maxSpinner = new JSpinner(new SpinnerNumberModel(1,1,10000,1));
		maxSpinner.setPreferredSize(new Dimension(40,20));
		
		ap_5 = new JPanel();
		ap_5.setLayout(new FlowLayout(FlowLayout.LEFT));
		ap_5.add(asMatrixBox);
		ap_5.add(rowRadio);
		ap_5.add(columnRadio);
		ap_5.add(maxSpinner);
		
		singleBox = new JCheckBox("single detention");
		
		ap_6 = new JPanel();
		ap_6.setLayout(new FlowLayout(FlowLayout.LEFT));
		ap_6.add(singleBox);
		
		checkBoxPanel_2 = new JPanel();
		checkBoxPanel_2.setLayout(new GridLayout(2,1));
		checkBoxPanel_2.add(ap_5);
		checkBoxPanel_2.add(ap_6);
		
		buttonGroup = new ButtonGroup();
		buttonGroup.add(rowRadio);
		buttonGroup.add(columnRadio);
	
		genTextArea = new JTextArea();
		genTextArea.getDocument().addDocumentListener(this);
		genTextArea.setLineWrap(true);
		genTextArea.setPreferredSize(new Dimension(150, 30));
		
		textAreaPanel = new JPanel();
		textAreaPanel.setLayout(new BorderLayout());
		textAreaPanel.setBorder(new TitledBorder("generations"));
		textAreaPanel.add(genTextArea, BorderLayout.CENTER);
		
		centerPanel = new JPanel();
		centerPanel.setLayout(new BorderLayout());
		centerPanel.add(checkBoxPanel_2, BorderLayout.CENTER);
		centerPanel.add(textAreaPanel, BorderLayout.SOUTH);
		
		okButton = new JButton("Ok");
		okButton.setActionCommand("ok");
		okButton.addActionListener(this);
		
		cancelButton = new JButton("cancel");
		cancelButton.setActionCommand("cancel");
		cancelButton.addActionListener(this);
		
		buttonPanel = new JPanel();
		buttonPanel.setLayout(new FlowLayout(FlowLayout.RIGHT));
		buttonPanel.add(cancelButton);
		buttonPanel.add(okButton);
		
		mainPanel = new JPanel();
		mainPanel.setLayout(new BorderLayout());
		mainPanel.add(checkBoxPanel, BorderLayout.NORTH);
		mainPanel.add(centerPanel, BorderLayout.CENTER);
		mainPanel.add(buttonPanel, BorderLayout.SOUTH);
		
		Container cp = this.getContentPane();
		cp.setLayout(new BorderLayout());
		cp.add(mainPanel, BorderLayout.CENTER);
		
		this.setSize(300, 350);
		this.setLocation((int)((this.getToolkit().getScreenSize().getWidth() - this.getWidth())/2),
				(int)((this.getToolkit().getScreenSize().getHeight() - this.getHeight())/2));
		this.setVisible(true);
		
	}
	
	private TreeSet<Integer> parseGenText(String text)
	{
		TreeSet<Integer> ret_List = new TreeSet<Integer>();
		
		String[] preNumbers = text.split(",");
		String[] number;
		
		String[] onlyEvery = preNumbers[preNumbers.length-1].split(":");
		int mod = 1;
		int count = 0;
		
		preNumbers[preNumbers.length-1] = onlyEvery[0];
		
		if(onlyEvery.length == 2) mod = Integer.parseInt(onlyEvery[1]);
		
		for(int i=0; i<preNumbers.length; i++)
		{
			
			number = preNumbers[i].split("-");
			
			if(number.length == 1)
			{
				if(count%mod == 0) ret_List.add(Integer.parseInt(number[0]));
			}
			else
			{
				for(int j= Integer.parseInt(number[0]); j<=Integer.parseInt(number[1]); j++)
				{
					if(count%mod == 0) ret_List.add(j);
					count++;
				}
			}
			count++;
		}	
		return ret_List;
	}
	
	public boolean testExpression(String string)
	{
		 Pattern p = Pattern.compile("((\\d+,)*(\\d+-\\d+,)*)*((\\d)+|(\\d+-\\d+)+)(:\\d+)?");
		 Matcher m = p.matcher(string);
		 
		 return m.matches();
	}
	
	//###############################################################################################
	// Override Methods ActionListener
	//###############################################################################################

	@Override
	public void actionPerformed(ActionEvent arg0) 
	{
		if(arg0.getActionCommand().equals(antecedenceBox.getActionCommand()))
		{
			if(antecedenceBox.isSelected())
			{
				this.axisMarkingABox.setEnabled(true);
			}
			else
			{
				this.axisMarkingABox.setSelected(false);
				this.axisMarkingABox.setEnabled(false);
			}
		}
		else if(arg0.getActionCommand().equals(conclusionBox.getActionCommand()))
		{
			if(conclusionBox.isSelected())
			{
				this.axisMarkingCBox.setEnabled(true);
			}
			else
			{
				this.axisMarkingCBox.setSelected(false);
				this.axisMarkingCBox.setEnabled(false);
			}
		}
		if(arg0.getActionCommand().equals(okButton.getActionCommand()))
		{
			boolean markingA = false;
			boolean markingC = false;
			
			int widthA = pav.getAxis_Dis()*pav.getSession().getFr_premiseSize();
			int heightA = pav.getAxisA_Length();
			
			int widthC = pav.getAxis_Dis()*pav.getSession().getFr_conclusionSize();
			int heightC = pav.getAxisC_Length();
			
			if(this.antecedenceBox.isSelected())
			{
				if(this.axisMarkingABox.isSelected())
				{					
					markingA = true;
					heightA = heightA + 30;
				}
			}
			
			if(this.conclusionBox.isSelected())
			{
				if(this.axisMarkingCBox.isSelected())
				{					
					markingC = true;
					heightC = heightC + 30;
				}
			}

			File file = null;
			
			if(conclusionBox.isSelected() || antecedenceBox.isSelected())
			{
				JFileChooser jfc = new JFileChooser();
				
				int selection = jfc.showSaveDialog(this);
				
				if(selection == JFileChooser.APPROVE_OPTION)
				{
					file = jfc.getSelectedFile();
				}
			
				TreeSet<Integer> gen_List = parseGenText(genTextArea.getText());
				
				BufferedImage matrixImgA = null;
				BufferedImage matrixImgC = null;
				Graphics2D g2dMA = null;
				Graphics2D g2dMC = null;
				int maxSize = (Integer)maxSpinner.getValue();
				
				if(asMatrixBox.isSelected())
				{
					matrixImgA = new BufferedImage(widthA*(maxSize)+2*(maxSize-1)
							, heightA*((gen_List.size()-1)/maxSize+1)+2*(gen_List.size()/maxSize)
							, BufferedImage.TYPE_INT_ARGB);
					matrixImgC = new BufferedImage(widthC*(maxSize)+2*(maxSize-1)
							, heightC*((gen_List.size()-1)/maxSize+1)+2*(gen_List.size()/maxSize)
							, BufferedImage.TYPE_INT_ARGB);
					g2dMA = matrixImgA.createGraphics();
					g2dMC = matrixImgC.createGraphics();
				}

				
				int j=0;
				for(Integer i: gen_List)
				{	
					try
					{		
						if(antecedenceBox.isSelected())
						{
						    // TYPE_INT_ARGB specifies the image format: 8-bit RGBA packed
						    // into integer pixels
						    BufferedImage bi = new BufferedImage(widthA, heightA, BufferedImage.TYPE_INT_ARGB);
				
						    Graphics2D g2d = bi.createGraphics();
				
						    pav.drawImageAntecedence(g2d, i, markingA);
						    
						    if(asMatrixBox.isSelected())
						    {
						    	g2dMA.drawImage(bi, (widthA+2)*(j%maxSize), (heightA+2)*(j/maxSize), null);
						    	g2dMA.setColor(Color.DARK_GRAY);

						    	g2dMA.fillRect((widthA+2)*(j%maxSize)-2
					    				, 0
					    				, 2
					    				, heightA*((gen_List.size()-1)/maxSize+2)+2*(gen_List.size()/maxSize));

						    	g2dMA.fillRect(0
					    				, (heightA+2)*(j/maxSize)-2
					    				, widthA*(maxSize)+2*maxSize
					    				,2);
						    }
				
						    if(singleBox.isSelected())
						    ImageIO.write(bi, "PNG", new File(file.toString() +"_A_" + i +".PNG"));
						}
						
						if(conclusionBox.isSelected())
						{
						    // TYPE_INT_ARGB specifies the image format: 8-bit RGBA packed
						    // into integer pixels
							BufferedImage bi = new BufferedImage(widthC, heightC, BufferedImage.TYPE_INT_ARGB);
				
						    Graphics2D g2d = bi.createGraphics();
				
						    pav.drawImageConclusion(g2d, i, markingC);
						    
						    if(asMatrixBox.isSelected())
						    {
						    	g2dMC.drawImage(bi, (widthC+2)*(j%maxSize), (heightC+2)*(j/maxSize), null);
						    	g2dMC.setColor(Color.DARK_GRAY);

						    	g2dMC.fillRect((widthC+2)*(j%maxSize)-2
					    				, 0
					    				, 2
					    				, heightC*((gen_List.size()-1)/maxSize+2)+2*(gen_List.size()/maxSize));

						    	g2dMC.fillRect(0
					    				, (heightC+2)*(j/maxSize)-2
					    				, widthC*(maxSize)+2*maxSize
					    				,2);
						    }
				
						    if(singleBox.isSelected())
						    ImageIO.write(bi, "PNG", new File(file.toString() +"_C_" + i +".PNG"));
						}
				 
				    } catch (IOException ie) {
				      ie.printStackTrace();
				    };
				    j++;
				}
				
				if(asMatrixBox.isSelected())
					try {
						if(antecedenceBox.isSelected())
						ImageIO.write(matrixImgA, "PNG", new File(file.toString() +"_A_M"  +".PNG"));
						if(conclusionBox.isSelected())
						ImageIO.write(matrixImgC, "PNG", new File(file.toString() +"_C_M"  +".PNG"));
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
			}
			
			this.dispose();
		}
		
	}
	
	//###############################################################################################
	// Override Methods DocumentListener
	//###############################################################################################

	@Override
	public void changedUpdate(DocumentEvent arg0) 
	{
		if(testExpression(genTextArea.getText()))
		{
			okButton.setEnabled(true);
		}
		else
		{
			okButton.setEnabled(false);
		}
		
	}

	@Override
	public void insertUpdate(DocumentEvent arg0) 
	{
		if(testExpression(genTextArea.getText()))
		{
			okButton.setEnabled(true);
		}
		else
		{
			okButton.setEnabled(false);
		}
	}

	@Override
	public void removeUpdate(DocumentEvent arg0) 
	{
		if(testExpression(genTextArea.getText()))
		{
			okButton.setEnabled(true);
		}
		else
		{
			okButton.setEnabled(false);
		}
	}

}
