package draw;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JRadioButton;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class TimeLine_PopUp extends JPopupMenu implements ActionListener, ChangeListener{
	
	private TimeLineView tlv;
	
	private JMenu distanceTypeMenu;
	
	private JRadioButton radio_1;
	private JRadioButton radio_3;
	private JRadioButton radio_4;
	
	private JPanel panel_1;
	private JPanel panel_3;
	private JPanel panel_4;
	
	private JCheckBox check_1;
	private JCheckBox check_2;
	private JCheckBox check_3;
	private JCheckBox check_pearls;
	private JCheckBox check_links;
	
	private JSpinner angelSim_Spinner;
	private JSpinner planeDis_Spinner;
	private JSpinner linkSim_Spinner;
	
	private JPanel panel_check_1;
	private JPanel panel_check_2;
	private JPanel panel_check_3;
	private JPanel panel_check_pearls;
	private JPanel panel_check_links;
	
	JMenu zoomMenu;
	
	JButton zoomIn;
	JButton zoomOut;
	
	JPanel zoomPanel;
	
	JMenuItem toLatex_Item;
	
	private ButtonGroup bGroup;
	
	//###############################################################################################
	// Constructor
	//###############################################################################################

	public TimeLine_PopUp(TimeLineView tlv_P)
	{
		tlv = tlv_P;
		
		radio_1 = new JRadioButton("Euclide");
		radio_1.setActionCommand("radio1");
		radio_1.addActionListener(this);

		radio_3 = new JRadioButton("EF");
		radio_3.setActionCommand("radio3");
		radio_3.addActionListener(this);
		radio_4 = new JRadioButton("Angle");
		radio_4.setActionCommand("radio4");
		radio_4.addActionListener(this);
		
		panel_1 = new JPanel();
		panel_1.setLayout(new FlowLayout(FlowLayout.LEFT));
		panel_1.add(radio_1);
				
		panel_3 = new JPanel();
		panel_3.setLayout(new FlowLayout(FlowLayout.LEFT));
		panel_3.add(radio_3);
		
		panel_4 = new JPanel();
		panel_4.setLayout(new FlowLayout(FlowLayout.LEFT));
		panel_4.add(radio_4);
		
		
		bGroup = new ButtonGroup();
		bGroup.add(radio_1);
		bGroup.add(radio_3);
		bGroup.add(radio_4);
		radio_1.setSelected(true);
		
		distanceTypeMenu = new JMenu("Distance..");
		distanceTypeMenu.add(panel_1);
		distanceTypeMenu.add(panel_3);
		distanceTypeMenu.add(panel_4);
		
		check_1 = new JCheckBox("show Angle");
		check_1.setActionCommand("check1");
		check_1.addActionListener(this);
		check_1.setSelected(tlv.isShowAngle());
		
		check_2 = new JCheckBox("show Conclusion Dis");
		check_2.setActionCommand("check2");
		check_2.addActionListener(this);
		check_2.setSelected(tlv.isShowConclusion());
		
		check_3 = new JCheckBox("show plane dis");
		check_3.setActionCommand("check3");
		check_3.addActionListener(this);
		check_3.setSelected(tlv.isShowPlaneDis());
		
		check_pearls = new JCheckBox("show pearls");
		check_pearls.setActionCommand("checkPearl");
		check_pearls.addActionListener(this);
		check_pearls.setSelected(tlv.isShowPearls());
		
		check_links = new JCheckBox("show links");
		check_links.setActionCommand("checkLinks");
		check_links.addActionListener(this);
		check_links.setSelected(tlv.isShowLinks());
		
		angelSim_Spinner = new JSpinner(new SpinnerNumberModel(1,0,1,0.001));
		angelSim_Spinner.addChangeListener(this);
		angelSim_Spinner.setName("angelSimThreshold");
		angelSim_Spinner.setPreferredSize(new Dimension(50,20));
		
		planeDis_Spinner = new JSpinner(new SpinnerNumberModel(0,0,1,0.001));
		planeDis_Spinner.addChangeListener(this);
		planeDis_Spinner.setName("planeDisThreshold");
		planeDis_Spinner.setPreferredSize(new Dimension(50,20));
		
		linkSim_Spinner = new JSpinner(new SpinnerNumberModel(1,0,1,0.001));
		linkSim_Spinner.addChangeListener(this);
		linkSim_Spinner.setName("linkSimThreshold");
		linkSim_Spinner.setPreferredSize(new Dimension(50,20));
		
		panel_check_1 = new JPanel();
		panel_check_1.setLayout(new FlowLayout(FlowLayout.LEFT));
		panel_check_1.add(check_1);
		
		panel_check_2 = new JPanel();
		panel_check_2.setLayout(new FlowLayout(FlowLayout.LEFT));
		panel_check_2.add(check_2);
		panel_check_2.add(angelSim_Spinner);
		
		panel_check_3 = new JPanel();
		panel_check_3.setLayout(new FlowLayout(FlowLayout.LEFT));
		panel_check_3.add(check_3);
		panel_check_3.add(planeDis_Spinner);
		
		panel_check_pearls = new JPanel();
		panel_check_pearls.setLayout(new FlowLayout(FlowLayout.LEFT));
		panel_check_pearls.add(check_pearls);
		
		panel_check_links = new JPanel();
		panel_check_links.setLayout(new FlowLayout(FlowLayout.LEFT));
		panel_check_links.add(check_links);
		panel_check_links.add(linkSim_Spinner);
		
		zoomIn = new JButton("in");
		zoomIn.setActionCommand("zoomIn");
		zoomIn.addActionListener(this);
		zoomOut = new JButton("out");
		zoomOut.setActionCommand("zoomOut");
		zoomOut.addActionListener(this);
		
		zoomPanel = new JPanel();
		zoomPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		zoomPanel.add(zoomIn);
		zoomPanel.add(zoomOut);
		
		zoomMenu = new JMenu("Zoom");
		zoomMenu.add(zoomPanel);
		
		toLatex_Item = new JMenuItem("to Latex");
		toLatex_Item.setActionCommand("toLatex");
		toLatex_Item.addActionListener(this);
		
		
		this.add(zoomMenu);
		this.add(distanceTypeMenu);
		this.add(panel_check_1);
		this.add(panel_check_2);
		this.add(panel_check_3);
		this.add(panel_check_pearls);
		this.add(panel_check_links);
		this.add(toLatex_Item);
	}
	
	//###############################################################################################
	// Override Method ActionListener
	//###############################################################################################
	
	@Override
	public void actionPerformed(ActionEvent arg0) 
	{
		if(arg0.getActionCommand().equals(radio_1.getActionCommand()))
		{
			tlv.setDistanceType(0);
			tlv.repaintDrawPanel();
		}
		else if(arg0.getActionCommand().equals(radio_3.getActionCommand()))
		{
			tlv.setDistanceType(1);
			tlv.repaintDrawPanel();
		}
		else if(arg0.getActionCommand().equals(radio_4.getActionCommand()))
		{
			tlv.setDistanceType(2);
			tlv.repaintDrawPanel();
		}
		else if(arg0.getActionCommand().equals(check_1.getActionCommand()))
		{
			tlv.setShowAngle(check_1.isSelected());
			tlv.repaintDrawPanel();
		}
		else if(arg0.getActionCommand().equals(check_2.getActionCommand()))
		{
			tlv.setShowConclusion(check_2.isSelected());
			tlv.repaintDrawPanel();
		}
		else if(arg0.getActionCommand().equals(check_3.getActionCommand()))
		{
			tlv.setShowPlaneDis(check_3.isSelected());
			tlv.repaintDrawPanel();
		}
		else if(arg0.getActionCommand().equals(check_pearls.getActionCommand()))
		{
			tlv.setShowPearls(check_pearls.isSelected());
			tlv.repaintDrawPanel();
		}
		else if(arg0.getActionCommand().equals(check_links.getActionCommand()))
		{
			tlv.setShowLinks(check_links.isSelected());
			tlv.repaintDrawPanel();
		}
		else if(arg0.getActionCommand().equals(zoomIn.getActionCommand()))
		{
			tlv.zoomIN();
		}
		else if(arg0.getActionCommand().equals(zoomOut.getActionCommand()))
		{
			tlv.zoomOut();
		}
		else if(arg0.getActionCommand().equals(toLatex_Item.getActionCommand()))
		{
			JFileChooser jfc = new JFileChooser();
			
			int save = jfc.showSaveDialog(this);
			
			if(save == 0)
			{
				File file = jfc.getSelectedFile();
				
				try 
				{
					File iFile = new File(file.toString() + ".tex");
							FileWriter fw = new FileWriter(iFile);
							BufferedWriter bw = new BufferedWriter(fw);
							bw.write(tlv.toLatex());
							bw.close();
							fw.close();
							
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}
	
	//###############################################################################################
	// Override Method ChangeListener
	//###############################################################################################

	@Override
	public void stateChanged(ChangeEvent arg0) 
	{
		JSpinner spinner = (JSpinner)arg0.getSource();	
		
		if(spinner.getName().equals(angelSim_Spinner.getName()))
		{
			tlv.setAngelSimThreshold((Double)spinner.getValue());
		}
		else if(spinner.getName().equals(planeDis_Spinner.getName()))
		{
			tlv.setPlaneDisThreshold((Double)spinner.getValue());
		}
		else if(spinner.getName().equals(linkSim_Spinner.getName()))
		{
			tlv.setLinkThreshold((Double)spinner.getValue());
		}	
	}

}
