package drawUtil;

import guiUtil.NumberFormater;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.font.TextLayout;
import java.awt.geom.Rectangle2D;

public class MathDraws {
	
	public static void drawSimpleAxis(Graphics2D g2d
											, int width
											, int height
											, double[] range
											, int[] resolution)
	{
		// x-Axis
		g2d.setColor(Color.black);
		g2d.drawLine(0
					, height
					, width
					, height);
		
		int 	dValue;
		double 	aValue;
		
		for(int i=0; i<resolution[0]; i++)
		{
			dValue = (int)(width/(double)resolution[0]*(i+1));
			aValue = range[0] + (range[1] - range[0])/resolution[0] * (i+1);
			
			String strValue = NumberFormater.doubleToString(aValue, 1);
		
			g2d.drawLine(dValue
						, height
						, dValue
						, height + 3);
			
			TextLayout textLayout = new TextLayout(strValue, g2d.getFont(), g2d.getFontRenderContext());
			Rectangle2D bounds = textLayout.getBounds();
			g2d.drawString(strValue
							, (int)(dValue - bounds.getCenterX())
							, height + (int)bounds.getHeight() + 8);
		}
		
		// y-Axis
		g2d.drawLine(0
					, 0
					, 0
					, height);
		
		for(int i=0; i<=resolution[1]; i++)
		{
			dValue = height - (int)(height/resolution[1]*(i));
			aValue = range[2] + (range[3] - range[2])/resolution[1] * (i);
			
			String strValue = NumberFormater.doubleToString(aValue, 2);
			
			g2d.setColor(Color.black);
			g2d.drawLine(0
						, dValue
						, -3
						, dValue);
			
			TextLayout textLayout = new TextLayout(strValue, g2d.getFont(), g2d.getFontRenderContext());
			Rectangle2D bounds = textLayout.getBounds();
			g2d.drawString(strValue
							, - (int)bounds.getWidth() - 8
							, dValue - (int)bounds.getCenterY());
			
			g2d.setColor(Color.LIGHT_GRAY);
			g2d.drawLine(0
					, dValue
					, width
					, dValue);
		}
	}

}
