package gui;

import guiCore.ColorGenerator;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class ColorDialog extends JDialog implements ActionListener{
	
	JLabel label1;
	JLabel label2;
	ArrayList<JLabel> label_A = new ArrayList<JLabel>();
	
	JButton button1;
	JButton button2;
	ArrayList<JButton> button_A = new ArrayList<JButton>();
	
	JPanel panel1;
	JPanel panel2;
	ArrayList<JPanel> panel_A = new ArrayList<JPanel>();
	
	ArrayList<JButton> deletButton_A = new ArrayList<JButton>();
	
	JPanel mainPanel;
	
	ColorGenerator cg;
	
	//###############################################################################################
	// Constructor
	//###############################################################################################
	
	public ColorDialog(JFrame owner, ColorGenerator cg_P)
	{
		super(owner);
		
		this.cg = cg_P;
		
		mainPanel = new JPanel();
		mainPanel.setLayout(new GridLayout(cg.getColor().length+1, 1));
		
		label1 = new JLabel("Color 1 ");
		label2 = new JLabel("Color 2 ");
		
		button1 = new JButton();
		button1.setBackground(new Color(cg.getColor()[0][0], cg.getColor()[0][1], cg.getColor()[0][2]));
		button1.setActionCommand("color");
		button1.addActionListener(this);
		
		button2 = new JButton();
		button2.setBackground(new Color(cg.getColor()[1][0], cg.getColor()[1][1], cg.getColor()[1][2]));
		button2.setActionCommand("color");
		button2.addActionListener(this);
		
		panel1 = new JPanel();
		panel1.setLayout(new FlowLayout(FlowLayout.LEFT));
		panel1.add(label1);
		panel1.add(button1);
		
		panel2 = new JPanel();
		panel2.setLayout(new FlowLayout(FlowLayout.LEFT));
		panel2.add(label2);
		panel2.add(button2);
		
		mainPanel.add(panel1);
		mainPanel.add(panel2);
		
		
		for(int i=2; i<cg.getColor().length; i++)
		{
			JLabel label = new JLabel("Color "+(i+1)+" ");
			label_A.add(label);
			
			JButton button = new JButton();
			button.setBackground(new Color(cg.getColor()[i][0], cg.getColor()[i][1], cg.getColor()[i][2]));
			button.setActionCommand("color");
			button.addActionListener(this);
			button_A.add(button);
			
			JButton deletButton = new JButton("x");
			deletButton_A.add(deletButton);
			
			JPanel panel = new JPanel();
			panel.setLayout(new FlowLayout(FlowLayout.LEFT));
			panel.add(label);
			panel.add(button);
			panel.add(deletButton);
			
			mainPanel.add(panel);
		}
		
		Container cp = this.getContentPane();
		cp.setLayout(new BorderLayout());
		
		cp.add(mainPanel, BorderLayout.CENTER);
		
		this.setSize(200,300);
		this.setLocation(this.getToolkit().getScreenSize().width/2 - this.getWidth()/2
				, this.getToolkit().getScreenSize().height/2 - this.getHeight()/2);
		this.setVisible(true);
		
	}
	
	//###############################################################################################
	// Override Methods ActionListener
	//###############################################################################################

	@Override
	public void actionPerformed(ActionEvent arg0) 
	{
		if(arg0.getActionCommand().equals("color"))
		{
			JButton button = ((JButton)arg0.getSource());
			
			Color color = JColorChooser.showDialog(this
					, "choose a color"
					, button.getBackground());
			
			button.setBackground(color);
		}		
	}

}
