package gui;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import guiCore.FISVis;
import guiUtil.RolloverToggleButton;

import javax.swing.ImageIcon;
import javax.swing.JToolBar;

public class ControlToolBar extends JToolBar implements ActionListener{
	
	private RolloverToggleButton play_Button;
	private FISVis sc;
	
	//###############################################################################################
	// Constructor
	//###############################################################################################
	
	public ControlToolBar(FISVis sc_P)
	{
		this.sc = sc_P;	
		
		play_Button = new RolloverToggleButton(new ImageIcon("res/icons/stop.gif")
												,new ImageIcon("res/icons/play.gif"));
		play_Button.setActionCommand("play");
		play_Button.setPreferredSize(new Dimension(20,20));
		play_Button.addActionListener(this);
		
		this.setLayout(new FlowLayout(FlowLayout.LEFT));
		this.add(play_Button);
	}
	
	//###############################################################################################
	// Override Methods ActionListener
	//###############################################################################################

	@Override
	public void actionPerformed(ActionEvent arg0) {
		// TODO Auto-generated method stub
		if(arg0.getActionCommand().equals("play"))
		{
			sc.setStop(play_Button.isSelected());
		}
	}
	
	public void stop()
	{
		this.play_Button.setSelected(true);
	}

}
