package guiCore;

import java.awt.Color;
import java.util.Random;

public class ColorGenerator {
	
	private float[][] color;
	private Random rand;
	
	//###############################################################################################
	// Constructor
	//###############################################################################################
	
	public ColorGenerator()
	{
		color = new float[6][3];
		
		color[0][0] = 1f; color[0][1] = 0f; color[0][2] = 0f;
		color[1][0] = 1f; color[1][1] = 1f; color[1][2] = 0f;
		color[2][0] = 0f; color[2][1] = 1f; color[2][2] = 0f;
		color[3][0] = 0f; color[3][1] = 1f; color[3][2] = 1f;
		color[4][0] = 0f; color[4][1] = 0f; color[4][2] = 1f;
		color[5][0] = 1f; color[5][1] = 0f; color[5][2] = 1f;
		
		rand = new Random();
	}
	
	public ColorGenerator(float[][] color_P)
	{
		//TODO check for color_P.length > 1
		this.color = color_P;
		rand = new Random();
	}
	
	//###############################################################################################
	// public Methods
	//###############################################################################################

	public static Color calculateRuleColor(int id_P, int generation_P)
	{
		//TODO finish it
		return new Color(0,0,1);
	}
	
	public Color randomRuleColor(int id_P)
	{	
		int modN = color.length;
		int line = rand.nextInt(modN);
		//Color intervall
		float[] interval = new float[3];
		interval[0] = color[(line+1)% modN][0] - color[(line)%modN][0];
		interval[1] = color[(line+1)% modN][1] - color[(line)%modN][1];
		interval[2] = color[(line+1)% modN][2] - color[(line)%modN][2];
				
		float[] ret_Color = new float[3];
		
		for(int i=0; i < 3; i++)
		{
			ret_Color[i] = color[line][i] + (float)(rand.nextDouble()*interval[i]);
		}
		
		return new Color(ret_Color[0], ret_Color[1], ret_Color[2]);
	}
	
	public Color calculateRuleColor(int id_P)
	{
		int modN = color.length;
		int p 		= id_P / modN;
		int rot 	= 0;
		if(id_P >= modN)
		{
			rot	= (int)(Math.log(id_P/modN)/Math.log(2));
		}
		
		int line 	= (id_P + rot) % modN;	
		//Color intervall
		float[] intervall = new float[3];
		intervall[0] = color[(line+1)% modN][0] - color[line][0];
		intervall[1] = color[(line+1)% modN][1] - color[line][1];
		intervall[2] = color[(line+1)% modN][2] - color[line][2];
				
		float[] ret_Color = new float[3];
		
		int a = 0;
		if(p < 1)
		{
			return new Color(color[line][0], color[line][1], color[line][2]);
		}
		else
		{
			a = (int)Math.pow(2, Math.floor(Math.log(p)/Math.log(2)));
		}
			
		for(int i=0; i < 3; i++)
		{
			ret_Color[i] = color[line][i] + intervall[i]/ a * (p % a) + intervall[i]/(a * 2);
		}
		
		return new Color(ret_Color[0], ret_Color[1], ret_Color[2]);
	}
	
	public static Color calculateRuleDisColor(double curr_Dis_P, double max_Dis_P, float[] topColor_P, float[] bottomColor_P)
	{
		float delta_Red = topColor_P[0] - bottomColor_P[0];
		float delta_Green = topColor_P[1] - bottomColor_P[1];
		float delta_Blue = topColor_P[2] - bottomColor_P[2];
	
		double normalizedDisInv = 1;
		
		if(max_Dis_P > 0) normalizedDisInv = (1-curr_Dis_P/max_Dis_P);
				
		float newRed = bottomColor_P[0]+(float)(delta_Red*normalizedDisInv);
		float newGreen = bottomColor_P[1]+(float)(delta_Green*normalizedDisInv);
		float newBlue = bottomColor_P[2]+(float)(delta_Blue*normalizedDisInv);
		
		return new Color(newRed, newGreen, newBlue);
	}
	
	//###############################################################################################
	// GET and SET
	//###############################################################################################

	public float[][] getColor() {
		return color;
	}

	public void setColor(float[][] color) {
		this.color = color;
	}
}
