package guiCore;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.TreeSet;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;

public class FindRules_Dialog extends JDialog implements ActionListener{
	
	Session session;
	RuleVisualizer rv;
	
	
	JTextField[] min_Range_A;
	JTextField[] max_Range_A;
	JCheckBox[] attr_Check_A;
	JPanel[] panel_A;
	
	JPanel mainPanel;
	
	JSpinner spinner_Start;
	JSpinner spinner_End;
	
	JButton okButton;
	JButton cancelButton;
	
	JPanel buttonPanel;
	
	//###############################################################################################
	// Constructor
	//###############################################################################################
	
	public FindRules_Dialog(Session session_P, JFrame owner, RuleVisualizer rv_P)
	{		
		super(owner);
		
		this.rv = rv_P;
		this.session = session_P;
		
		int attrSize = session.getFr_premiseSize();
		
		mainPanel = new JPanel();
		mainPanel.setLayout(new GridLayout(attrSize,1));
		
		Container cp = this.getContentPane();
		cp.setLayout(new BorderLayout());
		
		min_Range_A = new JTextField[attrSize];
		max_Range_A = new JTextField[attrSize];
		attr_Check_A = new JCheckBox[attrSize];
		panel_A = new JPanel[attrSize];
		
		for(int i=0; i<attrSize; i++)
		{
			
			attr_Check_A[i] = new JCheckBox("Attr: "+i);
			
			min_Range_A[i] = new JTextField(15);
			min_Range_A[i].setText(session.getAttr_Range()[i][0]+"");
			max_Range_A[i] = new JTextField(15);
			max_Range_A[i].setText(session.getAttr_Range()[i][1]+"");
			
			panel_A[i] = new JPanel();
			panel_A[i].setLayout(new FlowLayout(FlowLayout.LEFT));
			
			panel_A[i].add(attr_Check_A[i]);
			panel_A[i].add(min_Range_A[i]);
			panel_A[i].add(max_Range_A[i]);
			
			mainPanel.add(panel_A[i]);
		}
		
		spinner_Start = new JSpinner(new SpinnerNumberModel(0
															,0
															,session.getNewestCollectionIndex()
															,1));
		spinner_End= new JSpinner(new SpinnerNumberModel(session.getNewestCollectionIndex()
															,0
															,session.getNewestCollectionIndex()
															,1));	
		
		okButton = new JButton("ok");
		okButton.setActionCommand("ok");
		okButton.addActionListener(this);
		
		cancelButton = new JButton("cancel");
		cancelButton.setActionCommand("cancel");
		cancelButton.addActionListener(this);
		
		buttonPanel = new JPanel();
		buttonPanel.setLayout(new FlowLayout(FlowLayout.RIGHT));
		buttonPanel.add(spinner_Start);
		buttonPanel.add(spinner_End);
		buttonPanel.add(okButton);
		buttonPanel.add(cancelButton);
		
		cp.add(new JScrollPane(mainPanel), BorderLayout.CENTER);
		cp.add(buttonPanel, BorderLayout.NORTH);
		
		this.setSize(500,300);
		this.setLocation(this.getToolkit().getScreenSize().width/2 - this.getWidth()/2
				, this.getToolkit().getScreenSize().height/2 - this.getHeight()/2);
		this.setVisible(true);
	}
	
	//###############################################################################################
	// Override ActionListener
	//###############################################################################################

	@Override
	public void actionPerformed(ActionEvent arg0) 
	{
		if(arg0.getActionCommand().equals(okButton.getActionCommand()))
		{
			int selectCounter = 0;
			for(int i=0; i<session.getFr_premiseSize(); i++)
			{
				if(attr_Check_A[i].isSelected()) selectCounter++;
			}
			
			int[] attributes =new int[selectCounter];
			double[][] range = new double[selectCounter][2];
			
			selectCounter = 0;
			
			for(int i=0; i<session.getFr_premiseSize(); i++)
			{
				if(attr_Check_A[i].isSelected())
				{
					attributes[selectCounter] = i;
					range[i][0] = Double.parseDouble(min_Range_A[selectCounter].getText());
					range[i][1] = Double.parseDouble(max_Range_A[selectCounter].getText());
				}
				selectCounter++;
			}
			
			rv.setIDList(session.findAllRulesInRange(attributes
					, range
					, (Integer)spinner_Start.getValue()
					, (Integer)spinner_End.getValue()));
			this.dispose();
		}
		else 		if(arg0.getActionCommand().equals(cancelButton.getActionCommand()))
		{
			this.dispose();
		}
		
	}
}
