package guiUtil;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ImageIcon;
import javax.swing.JToggleButton;
import javax.swing.border.LineBorder;

public class RolloverToggleButton extends JToggleButton implements MouseListener{
	
	private boolean isRollover = false;
	
	//#######################################################################
	// CONSTRUCTOR
	//#######################################################################
	
	public RolloverToggleButton(ImageIcon icon)
	{		
		super(icon);
		
		this.addMouseListener(this);
		this.setBorderPainted(false);
		this.setFocusPainted(false);
		this.setOpaque(false);
		this.setBackground(new Color(0,0,0,0));
	}
	
	public RolloverToggleButton(ImageIcon icon, ImageIcon selectedIcon)
	{		
		super(icon);
		
		this.setSelectedIcon(selectedIcon);
		
		this.addMouseListener(this);
		this.setBorderPainted(false);
		this.setFocusPainted(false);
		this.setOpaque(false);
		this.setBackground(new Color(0,0,0,0));
	}
	
	public RolloverToggleButton(String name)
	{		
		super(name);
		
		this.addMouseListener(this);
		this.setBorderPainted(false);
		this.setFocusPainted(false);
		this.setOpaque(false);
		this.setBackground(new Color(0,0,0,0));
	}
	
	//#######################################################################
	// METHODS
	//#######################################################################
	
	
	//###############################################################################################
	// Override Methods MouseListener
	//###############################################################################################

	@Override
	public void mouseClicked(MouseEvent e) {
		

	}

	@Override
	public void mouseEntered(MouseEvent e) {
		
		this.setBorderPainted(true);

	}

	@Override
	public void mouseExited(MouseEvent e) {
		
		if(!this.isSelected()){
			this.setBorderPainted(false);
		}
	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}
}