package guiUtil;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JWindow;

import listener.DefaultWindowListener;

/**
 * Diese Klasse verwaltet und realisiert den Tausch vom Tab eines JTabbedPane in ein JFrame und zurck.
 * @author Sascha
 *
 */
public class TabToWindowSwitch implements WindowListener{
	
	private Component barterComponent;
	private TabHeadPanel controler;
	private JTabbedPane tabbedPane;
	private JFrame jw;
	
	//###########################################################################################
	// CONSTRUCTOR
	//###########################################################################################
	
	public TabToWindowSwitch(JTabbedPane tabbedPane, Component barterComponent_P){
		
		this.barterComponent = barterComponent_P;
		this.tabbedPane = tabbedPane;
		this.controler = new DefaultTabHeadPanel(this, barterComponent.getName());
		tabbedPane.add(barterComponent);
		tabbedPane.setTabComponentAt(tabbedPane.indexOfComponent(barterComponent), controler);
	}
	
	//###########################################################################################
	// METHODES
	//###########################################################################################
	
	/**
	 * 
	 */
	public void switchToWindow(){
		
		tabbedPane.remove(tabbedPane.indexOfComponent(barterComponent));
		tabbedPane.validate();
		jw = new JFrame();
		jw.addWindowListener(this);

		Container cp = jw.getContentPane();
		cp.setLayout(new BorderLayout());
		cp.add(barterComponent, BorderLayout.CENTER);
		cp.add(this.controler, BorderLayout.NORTH);
		jw.setSize(600,600);
		jw.setLocation(400,200);
		jw.setVisible(true);
		
		this.controler.setWindow(true);
	}
	
	public void switchToTab(){
		
		tabbedPane.add(barterComponent);
		tabbedPane.setTabComponentAt(tabbedPane.indexOfComponent(barterComponent), controler);
		this.jw.dispose();
		this.controler.setWindow(false);
	}
	
	//###########################################################################################
	//GET and SET
	//###########################################################################################

	public Component getBarterComponent() {
		return barterComponent;
	}

	public void setBarterComponent(Component barterComponent) {
		this.barterComponent = barterComponent;
	}

	public TabHeadPanel getControler() {
		return controler;
	}

	public void setControler(TabHeadPanel controler) {
		this.controler = controler;
	}

	public JTabbedPane getTabbedPane() {
		return tabbedPane;
	}

	public void setTabbedPane(JTabbedPane tabbedPane) {
		this.tabbedPane = tabbedPane;
	}

	@Override
	public void windowActivated(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	
	//#########################################################################################
	//WindowListener
	//#########################################################################################

	@Override
	public void windowClosed(WindowEvent arg0) {
		
	}

	@Override
	public void windowClosing(WindowEvent arg0) {

		this.controler.switchButton.doClick();	
	}

	@Override
	public void windowDeactivated(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowDeiconified(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowIconified(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowOpened(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	public JFrame getJw() {
		return jw;
	}

	public void setJw(JFrame jw) {
		this.jw = jw;
	}

}
