package io;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

public class RuleCollectionReader {
	
	private BufferedReader br;
	private File file;
	
	//###############################################################################################
	// Constructor
	//###############################################################################################
	
	public RuleCollectionReader(File file_P)
	{
		file = file_P;
		try 
		{
			br = new BufferedReader(new FileReader(file_P));			
		} 
		catch (FileNotFoundException e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	//###############################################################################################
	// Methods
	//###############################################################################################
	
	public IOfis readNext()
	{
		IOfis iofis = new IOfis();
		
		String zeile;
		int numRules = 0;
		String[] split_A;
		String[] split_A_2;
		
		try 
		{
			zeile = br.readLine();
			
			if(zeile == null) return null;
			
			split_A = zeile.split(",");
			
			if(split_A[0].equals("COLLECTION"))
			{
				numRules = Integer.parseInt(split_A[1]);
			}
			else
			{
				//TODO throw irgendwas
			}
			
			iofis.mean_A = new double[numRules][];
			iofis.width_A = new double[numRules][];
			iofis.out_A = new double[numRules][];
			
			iofis.ancestors = new int[numRules][2];
			
			for(int i=0; i<numRules; i++)
			{
				//read mean
				zeile = br.readLine();
				split_A = zeile.split(",");
				
				iofis.mean_A[i] = new double[split_A.length];
				for(int j=0; j<split_A.length; j++)
				{
					iofis.mean_A[i][j] = Double.parseDouble(split_A[j]);
				}
				
				//read width
				zeile = br.readLine();
				split_A = zeile.split(",");
				
				iofis.width_A[i] = new double[split_A.length];
				for(int j=0; j<split_A.length; j++)
				{
					iofis.width_A[i][j] = Double.parseDouble(split_A[j]);
				}
				
				//read out
				zeile = br.readLine();
				split_A = zeile.split(",");
				
				iofis.out_A[i] = new double[split_A.length];
				for(int j=0; j<split_A.length; j++)
				{
					iofis.out_A[i][j] = Double.parseDouble(split_A[j]);
				}
				
				//read ancestors
				zeile = br.readLine();
				split_A = zeile.split(",");
				
				iofis.ancestors[i] = new int[split_A.length];
				for(int j=0; j<split_A.length; j++)
				{
					iofis.ancestors[i][j] = Integer.parseInt(split_A[j]);
				}
			}
			
			//read attr Range
			zeile = br.readLine();
			split_A = zeile.split(",");
			iofis.attr_range = new double[split_A.length][];
			
			for(int i=0; i<split_A.length; i++)
			{
				split_A_2 = split_A[i].split(":");
				iofis.attr_range[i] = new double[split_A_2.length];
				
				for(int j=0; j<split_A_2.length; j++)
				{
					iofis.attr_range[i][j] = Double.parseDouble(split_A_2[j]);
				}				
			}
			
			//read out Range
			zeile = br.readLine();
			split_A = zeile.split(",");
			iofis.out_range = new double[split_A.length];
			
			for(int i=0; i<split_A.length; i++)
			{
				iofis.out_range[i] = Double.parseDouble(split_A[i]);
			}
			
			//read Rule to ID
			zeile = br.readLine();
			split_A = zeile.split(",");
			iofis.rule_to_ID = new int[split_A.length];
			
			for(int i=0; i<split_A.length; i++)
			{
				iofis.rule_to_ID[i] = Integer.parseInt(split_A[i]);
			}
			
			//read max ID
			zeile = br.readLine();
			iofis.max_ID = Integer.parseInt(zeile);
			
			//read Data
			zeile = br.readLine();
									
			File file2 = new File(file.getParent()+"\\"+zeile);
			BufferedReader br2 = new BufferedReader(new FileReader(file2));
			
			zeile = br2.readLine();
			split_A = zeile.split(",");
			
			iofis.data = new double[Integer.parseInt(split_A[0])][Integer.parseInt(split_A[1])];
			
			int i=0;
			while((zeile = br2.readLine()) != null)
			{
				split_A = zeile.split(",");
				
				for(int j=0; j<split_A.length; j++)
				{
					iofis.data[i][j] = Double.parseDouble(split_A[j]);
				}
				i++;
			}
			
			//read numDataAll
			zeile = br.readLine();
			iofis.numDataAll = Integer.parseInt(zeile);
			
		} 
		catch (IOException e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
			
		return iofis;
	}

}
