package io;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import guiCore.FuzzyRuleCollection;

public class RuleCollectionWriter {
	
	public void write(double[][] mean_A
			, double[][] width_A
			, double[][] out_A
			, int[][] ancestors
			, double[][] attr_range
			, double[] out_range
			, int[] rule_to_ID			
			, int max_ID			
			, double[][] data
			, int numDataAll
			, File file)
	{
		try 
		{
			BufferedWriter bw = new BufferedWriter(new FileWriter(file, true));
			
			bw.write("COLLECTION,"+mean_A.length);
			bw.newLine();
			
			for(int i=0; i<mean_A.length; i++)
			{
				//write mean
				for(int j=0; j<mean_A[i].length; j++)
				{
					bw.write(mean_A[i][j]+",");					
				}
				bw.newLine();
				
				//write width
				for(int j=0; j<width_A[i].length; j++)
				{
					bw.write(width_A[i][j]+",");					
				}
				bw.newLine();
				
				//write out
				for(int j=0; j<out_A[i].length; j++)
				{
					bw.write(out_A[i][j]+",");					
				}
				bw.newLine();
				
				//write ancestors
				for(int j=0; j<ancestors[i].length; j++)
				{
					bw.write(ancestors[i][j]+",");
				}
				bw.newLine();
			}
			
			//write attr Range
			for(int i=0; i<attr_range.length; i++)
			{
				for(int j=0; j<attr_range[i].length; j++)
				{
					bw.write(attr_range[i][j]+":");					
				}
				bw.write(",");								
			}
			bw.newLine();
			
			//write out Range
			for(int i=0; i<out_range.length; i++)
			{
				bw.write(out_range[i]+",");				
			}
			bw.newLine();
			
			//write Rule to ID
			for(int i=0; i<rule_to_ID.length; i++)
			{
				bw.write(rule_to_ID[i]+",");				
			}
			bw.newLine();		
			//write max_ID
			bw.write(max_ID+"");
			bw.newLine();
			
			//write Data
			//String[] str_A = file.toString().split("\\.");
			String str_A = file.getParent();
			
			File dataFile = null;
			int n = 0;
			boolean notFound = true;
			while(notFound)
			{
				dataFile = new File(str_A+"\\data_"+ n +".eDat");
				if(dataFile.exists())
				{
					n++;
				}
				else
				{
					notFound = false;
				}
			}
			
			BufferedWriter bw1 = new BufferedWriter(new FileWriter(dataFile, true));
			
			bw1.write(data.length + "," + data[0].length);
			bw1.newLine();
			
			for(int i=0; i<data.length; i++)
			{
				for(int j=0; j<data[i].length; j++)
				{
					bw1.write(data[i][j]+",");					
				}
				bw1.newLine();
			}
			
			bw1.close();
			
			//bw.write(dataFile.toString());
			bw.write("data_"+ n +".eDat");
			bw.newLine();
			bw.write(numDataAll+"");
			bw.newLine();
			
			bw.close();			
		} 
		catch (IOException e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
