package math;

import java.awt.Point;
import java.awt.geom.Point2D;

public class MathUtil {
	
	public static double radToGrad(double angel)
	{
		return angel/Math.PI*180;
	}
	
	public static Point.Double[] pathNToPath2(double[][] pathN)
	{
		Point.Double[] ret_A = new Point.Double[pathN.length];
		
		for(int i=0; i<ret_A.length; i++)
		{
			ret_A[i] = new Point.Double();
		}
		
		Point.Double[] intersectPoints;
		
		double dis_1; //first
		double dis_2; //last
		double dis_m; //magnet
		
		//First Point
		ret_A[0].x = 0;
		ret_A[0].y = 0;
		
		dis_1 = Point.distance(pathN[0][0], pathN[0][1], pathN[1][0], pathN[1][1]);
		
		//secenond Point
		ret_A[1].x = dis_1;
		ret_A[1].y = 0;
		
		for(int i=2; i<ret_A.length; i++)
		{
			dis_1 = Metric.euclidean(pathN[0], pathN[i]);
			dis_2 = Metric.euclidean(pathN[i-1], pathN[i]);
			dis_m = Metric.euclidean(pathN[i-2], pathN[i]);
			
			intersectPoints = intersectCircle(ret_A[0].x
												, ret_A[0].y
												, ret_A[i-1].x
												, ret_A[i-1].y
												, dis_1
												, dis_2);
System.out.println("dis_1 "+ dis_1+" dis_2: "+dis_2);
			
			ret_A[i] = nearestPoint(intersectPoints, ret_A[i-2], dis_m);
		}
				
		return ret_A;
	}
	
	public static Point.Double nearestPoint(Point.Double[] p_A, Point.Double p_m, double dis_m)
	{				
		double dis_1 = Point.distance(p_A[0].x, p_A[0].y, p_m.x, p_m.y);
		double dis_2 = Point.distance(p_A[1].x, p_A[1].y, p_m.x, p_m.y);
		
		double dis_dis_1 = Math.abs(dis_1-dis_m);
		double dis_dis_2 = Math.abs(dis_2-dis_m);
		
		if(dis_dis_1 < dis_dis_2)
		{
			return p_A[0];
		}
		else
		{
			return p_A[1];
		}
	}
	
	public static boolean checkIntersect(double x1, double y1, double x2, double y2, double r1, double r2)
	{
		double dis = Metric.euclidean(new double[]{x1,y1}, new double[]{x2,y2});
		
		if(dis > r1+r2) return false;
		
		return true;
	}
	
	public static Point.Double pointOnLine(double x1, double y1, double x2, double y2, double r1)
	{
		Point.Double p = new Point.Double();
		
		double[] v_1 = Metric.subtractVector(new double[]{x1,y1}, new double[]{x2,y2});
		Metric.normalizeVector(v_1);
		
		p.x = v_1[0] * r1;
		p.y = v_1[1] * r1;
		
		return p;
	}
	
	public static Point.Double[] intersectCircle(double x1, double y1, double x2, double y2, double r1, double r2)
	{
		Point.Double[] p = new Point.Double[2];
		
		p[0] = new Point.Double();
		p[1] = new Point.Double();
		
		if(x1 != x2)
		{
			double a = (y2-y1)/(x2-x1);
			double b = ((r1*r1-r2*r2)-(x1*x1-x2*x2)-(y1*y1-y2*y2))/(2*(x2-x1));
		
			double e = a*a+1;
			double f = -2*y1-2*a*(b-x1);
			double g = y1*y1+(b-x1)*(b-x1)-r1*r1;
			
			p[0].y = (-f + Math.sqrt(f*f-4*g*e))/(2*e);
			p[1].y = (-f - Math.sqrt(f*f-4*g*e))/(2*e);
		
			p[0].x = b - p[0].y*a;
			p[1].x = b - p[1].y*a;
		}
		else if(y1 != y2)
		{

			double a = (x2-y1)/(y2-y1);
			double b = ((r1*r1-r2*r2)-(y1*y1-y2*y2)-(x1*x1-x2*x2))/(2*(y2-y1));
		
			double e = a*a+1;
			double f = -2*x1-2*a*(b-y1);
			double g = x1*x1+(b-y1)*(b-y1)-r1*r1;
			
			p[0].y = (-f + Math.sqrt(f*f-4*g*e))/(2*e);
			p[1].y = (-f - Math.sqrt(f*f-4*g*e))/(2*e);
		
			p[0].y = b - p[0].x*a;
			p[1].y = b - p[1].x*a;
		}
		else
		{
			return null;
		}
		
		return p;
	}

}
