package math;

public class Metric {
	
	public static double norm2(double[] v)
	{
		double sum = 0;
		
		for(int i=0; i<v.length; i++)
		{
			sum = sum + v[i] * v[i];
		}
		
		sum = Math.sqrt(sum);
		
		return sum;
	}
	
	public static double euclidean(double[] v_1, double[] v_2)
	{
		double ret_Value;
				
		if(v_1.length == v_2.length)
		{
			double sum = 0;
			
			for(int i=0; i<v_1.length; i++)
			{
				sum = sum + (v_1[i]-v_2[i])*(v_1[i]-v_2[i]);
			}
			
			ret_Value = Math.sqrt(sum);
			
			return ret_Value;
		}
		else
		{
			throw new UnsupportedOperationException("v_1 has length "
														+ v_1.length
														+ " and v_2 has length "
														+ v_2.length 
														+ ". They have to have the same length");
		}
	}
	
	public static double euclidean(double[] v_1, double[] v_2, boolean[] enabledAttr_A)
	{
		double ret_Value;
				
		if(v_1.length == v_2.length)
		{
			double sum = 0;
			
			for(int i=0; i<v_1.length; i++)
			{
				if(enabledAttr_A[i])
				{
					sum = sum + (v_1[i]-v_2[i])*(v_1[i]-v_2[i]);
				}
			}
			
			ret_Value = Math.sqrt(sum);
			
			return ret_Value;
		}
		else
		{
			throw new UnsupportedOperationException("v_1 has length "
														+ v_1.length
														+ " and v_2 has length "
														+ v_2.length 
														+ ". They have to have the same length");
		}
	}
	
	public static void normalizeVector(double[] v_1)
	{	
		double n = norm2(v_1);
				
		for(int i=0; i < v_1.length; i++)
		{
			v_1[i] = v_1[i] / n;
		}
	}
	
	public static double[] subtractVector(double[] v_1, double[] v_2)
	{
		double[] retVector = new double[v_1.length];
		
		for(int i=0; i<v_1.length; i++)
		{
			retVector[i] = v_2[i] - v_1[i];
		}
		
		return retVector;
	}
}
