package math;

import java.util.ArrayList;

public class Polar {
	
//	private double[] ells;
	
	public static double[] cartesianToPolar(double[] x)
	{
		double[] polar = new double[x.length];
		
		double[] xSum = new double[x.length];
		
		xSum[0] = x[0];
		
		if(x.length > 1)
		{
			xSum[1] = x[0]*x[0] + x[1]*x[1];
		}
		
		for(int i=2; i<xSum.length; i++)
		{
			xSum[i] = x[i]*x[i] + xSum[i-1];
		}
		
		polar[0] = Math.sqrt(xSum[x.length-1]);
		
		if(polar.length > 1)
		{
			if(x[1] == 0 && x[0] > 0)
			{
				polar[1] = 0;
			}
			else if(x[1] == 0 && x[0] < 0)
			{
				polar[1] = Math.PI;
			}
			else if(x[1] > 0 && x[0] < 0)
			{
				polar[1] = -1*(Math.atan(x[0]/x[1]) - Math.PI/2);
			}
			else if(x[1] < 0 && x[0] < 0)
			{
				polar[1] = -1*(Math.atan(x[0]/x[1]) + Math.PI/2);
			}
			else if(x[0] == 0)
			{
				polar[1] = Math.signum(x[1])*Math.PI/2;
			}
			else if(x[1] > 0)
			{
				polar[1] = Math.PI/2 - Math.atan(x[0]/x[1]);
			}
			else
			{
				polar[1] = - Math.PI/2 - Math.atan(x[0]/x[1]);
			}
		}
	
		
		for(int i=2; i<polar.length; i++)
		{
			if(xSum[i-1] == 0 && x[i] >= 0)
			{
				polar[i] = 0;
			}
			else if(xSum[i-1] == 0 && x[i] < 0)
			{
				polar[i] = Math.PI;
			}
			else if(x[i] == 0)
			{
				polar[i] = Math.PI/2;
			}
			else if(x[i] > 0)
			{
				polar[i] = Math.atan(Math.sqrt(xSum[i-1])/x[i]);
			}
			else if(x[i] < 0)
			{
				polar[i] = Math.atan(Math.sqrt(xSum[i-1])/x[i]) + Math.PI;
			}
		}
		
		return polar;
	}
	
	
//	public double[] cartesianToPolar(double[] x)
//	{
//		double[] polar = new double[x.length];
//		
//		ells = new double[x.length+1];
//		ells[0] = 0;
//		
//		//fill ||L||
//		for(int i=1; i<ells.length; i++)
//		{
//			ells[i] = ell(x[i-1], i-1);
//System.out.println(ells[i]);
//		}
//		
//		//k == n
//		polar[0] = ells[x.length];
//		
//		// k == n-1
//		int iFin=polar.length;
//		if(x[x.length-1] < 0)
//		{
//			polar[x.length-1] = Math.atan(ells[x.length-1]/x[x.length-1]) + Math.PI;
//			iFin = iFin-1;
//		}
//													
//		for(int i=1; i<iFin; i++)
//		{
//System.out.println("if.. "+x[x.length-1 - i]+" and ell " + ells[i-1]);
//			if(x[i] == 0 && ells[i] == 0)
//			{
//				polar[i] = 0;
//			}
//			else
//			{
//				polar[i] = Math.atan(ells[i]/x[i]);
//
//System.out.println("x " + x[i] + " ells " + ells[i] + " atan "+Math.atan(ells[i]/x[i]));
//			}
//		}
//		
//		return polar;
//	}
//	
//	private double ell(double x, int index)
//	{
//		double retValue = 0;
//		
//		if(x != 0)
//		{
//			retValue = Math.signum(x) * Math.sqrt(x*x + ells[index]*ells[index]);
//		}
//		else
//		{
//			retValue = Math.sqrt(x*x + ells[index]*ells[index]);
//		}
//System.out.println("ell: " + retValue + " x " + x + " ell-1 "+ ells[index]);
//			
//		return retValue;
//	}

}
