//package stub;
//
//import java.util.ArrayList;
//import java.util.Random;
//
//import fuzzy.FuzzyConclusion;
//import fuzzy.FuzzyRule;
//import fuzzy.FuzzySet;
//import guiCore.FISVis;
//
//public class RuleStreamGenerator {
//	
//	private int runs = 40;
//	private int speed = 100;
//	private int initRuleNumber = 10;
//	private int maxID = -1;
//	private int numberFs = 4;
//	private int fs_type = FuzzySet.GAUSS;
//	private int fc_type = FuzzyConclusion.LINEAR_FUNCTION;
//	private double premRange = 5;
//	private double conRange = 5;
//	private double maxPremiseDelta = 0.8;
//	private double maxConclusionDelta = 1;
//	
//	private double[][] testData;
//	private int dataCount =0 ;
//	
//	private FISVis sessionControler;
//	
//	//###############################################################################################
//	// Constructor
//	//###############################################################################################
//	
//	public RuleStreamGenerator()
//	{
//		sessionControler = new FISVis();
//		startStream();
//	}
//	
//	//###############################################################################################
//	// Methods
//	//###############################################################################################
//	
//	
//	public void startStream()
//	{
//		Random rand = new Random();
//		
//		this.generateTestData(rand);
//		
//		ArrayList<FuzzyRule> fr_List = new ArrayList<FuzzyRule>();
//		ArrayList<FuzzyRule> frSwap_List = new ArrayList<FuzzyRule>();
//		
//		//initialize frSwap_List
//		for(int i=0; i<initRuleNumber; i++)
//		{
//			FuzzyRule fr = new FuzzyRule(i
//									,0
//									,new int[]{-1,-1}
//									,generateRandomFsList(fs_type, rand)
//									,new String("A")
//									,this.generateFuzzyConclusion(fc_type, rand));
//			maxID = i;
//			
//			frSwap_List.add(fr);
//		}
//		
//		double[][] attr_range = new double[10][2];
//		double[] out_range = new double[2];
//		
//		for(int i=0; i<10; i++)
//		{
//			attr_range[i][0] = -10;
//			attr_range[i][1] = 10;
//		}
//		out_range[0] = -5;
//		out_range[1] = 5;
//		
//		dataCount = dataCount + testData.length;
//		//inform sessionControler
//		sessionControler.startSession(frSwap_List, attr_range, out_range, -1, testData, dataCount, null);
//		
//		//start loop
//		for(int i=0; i<runs; i++)
//		{
//			try {
//				Thread.sleep(speed);
//			} catch (InterruptedException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			}
//					
//			//fill fr_List with a variation of frSwap_List
//			for(FuzzyRule fr: frSwap_List)
//			{
//				ArrayList<FuzzySet> fs_Listnew = new ArrayList<FuzzySet>();
//				//Drift fuzzySets
//				for(FuzzySet fs: fr.getFs_List_Copy())
//				{
//					double[] newCharacteristics = fs.getCharacteristics();
//					for(int j=0; j<newCharacteristics.length; j++)
//					{
//						newCharacteristics[j] = newCharacteristics[j]+rand.nextDouble()*maxPremiseDelta*Math.pow(-1, rand.nextInt(2));
//					}
//					
//					
//					
//					FuzzySet fs_new = fs.newVariant(newCharacteristics);
//					fs_Listnew.add(fs_new);
//				}
//				
//				double[] newConChar = fr.getFc().getCharacteristics();
//				for(int j=0; j<newConChar.length; j++)
//				{
//					newConChar[j] = newConChar[j]+rand.nextDouble()*maxConclusionDelta*Math.pow(-1, rand.nextInt(2));
//					
////					if(newConChar[j] <= 0) newConChar[j] = maxConclusionDelta;
//				}
//				
//				FuzzyConclusion newConclusion = fr.getFc().newVariant(newConChar);
//				
//				FuzzyRule fr_new = new FuzzyRule(fr.getId()
//										,fr.getTimeStamp()+1
//										,fr.getAncestors()
//										,fs_Listnew
//										,fr.getRpn_Rule()
//										,newConclusion);
//				
//				fr_List.add(fr_new);
//			}
//			dataCount = dataCount + testData.length;
//			//inform sessionControler
//			sessionControler.updateSession(fr_List, attr_range, out_range, -1, testData, dataCount);
//						
//			//update frSwap_List
//			frSwap_List = new ArrayList<FuzzyRule>();
//			frSwap_List.addAll(fr_List);
//			
//			//delete or add randomly a rule
//			double nextDouble = rand.nextDouble();
//			
//			if(nextDouble < 0.2
//					&& frSwap_List.size() > 1)
//			{
//				int anc_1 = rand.nextInt(frSwap_List.size());
//				int id_1 = frSwap_List.get(anc_1).getId();
//								
//				frSwap_List.remove(anc_1);
//				
//				int anc_2 = rand.nextInt(frSwap_List.size());
//				int id_2 = frSwap_List.get(anc_2).getId();
//									
//				frSwap_List.remove(anc_2);
//				
//				maxID++;
//				FuzzyRule fr = new FuzzyRule(maxID
//						,i+1
//						,new int[]{id_1, id_2}
//						,generateRandomFsList(fs_type, rand)
//						,new String("A")
//						,this.generateFuzzyConclusion(fc_type, rand));
//				
//				frSwap_List.add(fr);
//			}
//			else if(nextDouble > 0.8
//					 	&& frSwap_List.size() < initRuleNumber * 2)
//			{
//				int anc_1 = rand.nextInt(frSwap_List.size());
//				int id_1 = frSwap_List.get(anc_1).getId();
//				
//				frSwap_List.remove(anc_1);
//				
//				maxID++;
//				FuzzyRule fr = new FuzzyRule(maxID
//						,i+1
//						,new int[]{id_1,-1}
//						,generateRandomFsList(fs_type, rand)
//						,new String("A")
//						,this.generateFuzzyConclusion(fc_type, rand));
//				
//				frSwap_List.add(fr);
//				
//				maxID++;
//				FuzzyRule fr2 = new FuzzyRule(maxID
//						,i+1
//						,new int[]{id_1,-1}
//						,generateRandomFsList(fs_type, rand)
//						,new String("A")
//						,this.generateFuzzyConclusion(fc_type, rand));
//				
//				frSwap_List.add(fr2);
//			}		
//			fr_List = new ArrayList<FuzzyRule>();
//		}
//	}
//	
//	/**
//	 * 
//	 * @param fsType
//	 * @param rand
//	 * @return
//	 */
//	public ArrayList<FuzzySet> generateRandomFsList(int fsType, Random rand)
//	{
//		ArrayList<FuzzySet> ret_List = new ArrayList<FuzzySet>();
//		
//		for(int i=0; i<numberFs; i++)
//		{
//			double[] premChar = new double[2];
//			
//			premChar[0] = rand.nextDouble()*premRange*Math.pow(-1, rand.nextInt(2));
//			premChar[1] = rand.nextDouble()*premRange;
//			
//			FuzzySet fs = FuzzySet.createFuzzySet(fsType, premChar);
//		
//			ret_List.add(fs);
//		}
//		
//		return ret_List;
//	}
//	
//	/**
//	 * 
//	 * @param fcType
//	 * @param rand
//	 * @return
//	 */
//	public FuzzyConclusion generateFuzzyConclusion(int fcType, Random rand)
//	{
//		FuzzyConclusion ret_Fc = null;
//		
//		double[] weights = new double[numberFs+1];
//		for(int i=0; i<weights.length; i++)
//		{
//			weights[i] = rand.nextDouble()*conRange*Math.pow(-1, rand.nextInt(2));
//		}
//		
//		ret_Fc = FuzzyConclusion.createFuzzyConclusion(fcType, weights);
//		
//		return ret_Fc;
//	}
//	
//	private void generateTestData(Random rand)
//	{
//		this.testData = new double[100][numberFs];
//		
//		for(int i=0; i<testData.length; i++)
//		{
//			for(int j=0; j<testData[i].length; j++)
//			{
//				testData[i][j] = rand.nextDouble()*premRange*Math.pow(-1, rand.nextInt(2));
//			}
//		}
//	}
//	
//	//###############################################################################################
//	// GET and SET
//	//###############################################################################################
//
//	public void setSessionControler(FISVis sc)
//	{
//		this.sessionControler = sc;
//	}
//}
