package fuzzy;

public abstract class FuzzyConclusion {
	
	public final static int FUZZYSET = 0;
	public final static int LINEAR_FUNCTION = 1;
	
	private final int type;
	
	//###############################################################################################
	// CONSTRUCTOR
	//###############################################################################################
	
	public FuzzyConclusion(int type)
	{
		this.type = type;
	}
	
	//copy-constructor
	public FuzzyConclusion(FuzzyConclusion fc)
	{
		this.type = fc.getType();
	}
	
	//###############################################################################################
	// Abstract Methods
	//###############################################################################################
	
	public abstract double getValue(double[] datapoint);
	public abstract FuzzyConclusion copy();
	public abstract FuzzyConclusion newVariant(double[] variations);
	public abstract double[] getCharacteristics();
	
	//###############################################################################################
	// Factory Methods
	//###############################################################################################
	
	public static FuzzyConclusion createFuzzyConclusion(int type, double[] conChar)
	{
		FuzzyConclusion ret_Fc = null;
		
		switch(type)
		{
			case FUZZYSET: break;
			case LINEAR_FUNCTION: ret_Fc = new FuzzyConclusionLinear(conChar);
		}
		
		return ret_Fc;
	}
	
	//###############################################################################################
	// GET and SET
	//###############################################################################################
	
	public int getType()
	{
		return this.type;
	}

}
