package fuzzy;

public class FuzzySetGauss extends FuzzySet{
	
	private final double mean;
	private final double width;		//standard deviation
	
	//###############################################################################################
	// Constructor
	//###############################################################################################
	
	public FuzzySetGauss(double[] characteristics)
	{
		super(FuzzySet.GAUSS);
		this.mean = characteristics[0];
		this.width = characteristics[1];
	}
	
	//###############################################################################################
	// Override Methods
	//###############################################################################################

	@Override
	public double getCenter() {

		return mean;
	}
	
	@Override
	public double getWidth() {
	
		return width;
	}

	@Override
	public double[][] getCore() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public double[][] getAlphaCut(double alpha) {
	
		double[][] reValue = new double[1][2];
		
		//TODO finishing
		
		return null;
	}

	@Override
	public double getValue(double x) {

		double reValue = Math.exp(-0.5*Math.pow(((x-mean)/width),2));
		
		return reValue;
	}

	@Override
	public FuzzySet copy() 
	{
		return new FuzzySetGauss(new double[]{mean, width});
	}

	@Override
	public FuzzySet newVariant(double[] variations) {

		return new FuzzySetGauss(new double[]{variations[0], Math.abs(variations[1])});
	}

	@Override
	public double[] getCharacteristics() {
		
		return new double[]{mean, width};
	}

	public String toString()
	{
		StringBuffer sb = new StringBuffer();
		
		sb.append("w: " + width);
		sb.append(" c: " + mean);
		
		return sb.toString();
	}

}
