package fuzzy;

import java.util.zip.DataFormatException;

public class PartitionMeasure {
	
	public static double compSimHuell(double[][] part_A, double[][] part_B) throws DataFormatException
	{
		// Cluster -> column, element -> row
		
		if(part_A.length != part_B.length)
		{
			throw new DataFormatException("partitions do not have the same x - dimension");
		}
		
		double sum = 0;
		
		for(int i=0; i < part_A.length - 1; i ++)
		{
			for(int j = i+1; j <part_A.length; j++)
			{
				double eq_A = equivalenceRelationHuell(part_A[i], part_A[j]);
				double eq_B = equivalenceRelationHuell(part_B[i], part_B[j]);
				
				sum = sum + Math.abs(eq_A - eq_B);
			}
		}
		
		return 1 - sum/(part_A.length * (part_A.length - 1)/2);
	}

	public static double equivalenceRelationHuell(double[] P_1, double[] P_2)
	{
		double sum = 0;
		
		for(int c=0; c < P_1.length; c++)
		{
			sum = sum + Math.abs(P_1[c] - P_2[c]);
		}
		
		return 1 - 0.5 * sum;
	}
}
